const sMap = new Map([['ZNJ', 'Northampton North Junction'], ['ZPS', 'Plaistow L.T.'], ['MSC', 'Marseille St Charles'], ['ZAE', 'Aldgate East'], ['ZEP', 'East Putney'], ['GBG', 'Gorebridge'], ['ZHR', 'Holloway Road'], ['ZPN', 'Paddington (Bakerloo Line)'], ['NMC', 'New Mills Central'], ['HBB', 'Hubberts Bridge'], ['ADC', 'Adlington (Cheshire)'], ['WHI', 'Whitstable'], ['FEG', 'Fellgate (T & W Metro)'], ['HRH', 'Horsham'], ['LNW', 'Llanwrtyd'], ['RYP', 'Ryde Pier Head'], ['PRU', 'Prudhoe'], ['TLH', 'Tilehurst'], ['SBM', 'South Bermondsey'], ['TAM', 'Tamworth'], ['CFD', 'Castleford'], ['NMN', 'New Mills Newtown'], ['HFS', 'Hatfield & Stainforth'], ['WFN', 'Watford North'], ['GWN', 'Gowerton'], ['WMW', 'Walthamstow Queens Road'], ['INP', 'Inverkip'], ['WRW', 'Warwick'], ['WHG', 'Westhoughton'], ['WIM', 'Wimbledon'], ['CLM', 'Collingham'], ['DRF', 'Driffield'], ['NWT', 'Newtown (Powys)'], ['SOE', 'Southend East'], ['PNF', 'Penyffordd'], ['WYE', 'Wye'], ['BAR', 'Bare Lane'], ['YRM', 'Yarm'], ['NTH', 'Neath'], ['ERH', 'Erith'], ['CFO', 'Chalfont & Latimer'], ['FGW', 'Fishguard & Goodwick'], ['BAY', 'Bayford'], ['BER', 'Bearley'], ['SIT', 'Sittingbourne'], ['WHL', 'White Hart Lane'], ['DRN', 'Duirinish'], ['SWK', 'Southwick'], ['MTM', 'Martin Mill'], ['NWR', 'Newtonmore'], ['ADW', 'Addiewell'], ['ALV', 'Alvechurch'], ['SQE', 'Surrey Quays'], ['HIG', 'Highbridge & Burnham'], ['RMC', 'Rotherham Central'], ['NTN', 'Newton'], ['CBN', 'Camborne'], ['RIA', 'Rhoose Cardiff Intl Airport'], ['BXW', 'Boxhill & Westhumble'], ['TNN', 'Thorne North'], ['FTN', 'Fratton'], ['RUA', 'Ruabon'], ['LAY', 'Layton'], ['LLV', 'Llandovery'], ['MAS', 'Manors'], ['CLG', 'Claygate'], ['CTT', 'Church Stretton'], ['GGV', 'Gargrave'], ['TNS', 'Thorne South'], ['CRE', 'Crewe'], ['WXC', 'Wrexham Central'], ['CAD', 'Cadoxton'], ['HYB', 'Honeybourne'], ['WGT', 'Wigton'], ['WRX', 'Wrexham General'], ['RHO', 'Rhosneigr'], ['KWL', 'Kidwelly'], ['RYD', 'Ryde Esplanade'], ['PTL', 'Priesthill & Darnley'], ['NWN', 'Newton for Hyde'], ['SBP', 'Stonebridge Park'], ['PEV', 'Pevensey & Westham'], ['ACL', 'Acle'], ['GDH', 'Gordon Hill'], ['LSY', 'Lower Sydenham'], ['SEB', 'Seaburn (T & W Metro)'], ['AYW', 'Aberystwyth'], ['LNZ', 'Lenzie'], ['MDS', 'Morden South'], ['ADD', 'Adderley Park'], ['EFL', 'East Farleigh'], ['SPU', 'Staplehurst'], ['UHL', 'Upper Holloway'], ['WLP', 'Welshpool'], ['CAS', 'Castleton'], ['HAM', 'Hamworthy'], ['BGN', 'Bridgend'], ['BRN', 'Bearsden'], ['APG', 'Aspley Guise'], ['DEW', 'Dewsbury'], ['BPS', 'Blackpool South'], ['KSL', 'Kearsley'], ['PYJ', 'Paisley St James'], ['NBA', 'New Barnet'], ['WHR', 'West Horndon'], ['HLD', 'Hellifield'], ['RDR', 'Radyr'], ['VAL', 'Valley'], ['BSD', 'Bearsted'], ['FIT', 'Filton Abbey Wood'], ['NAY', 'Newton Aycliffe'], ['BWK', 'Berwick-upon-Tweed'], ['BIF', 'Barrow-in-Furness'], ['DMY', 'Drumry'], ['CKH', 'Corkerhill'], ['LBK', 'Long Buckby'], ['BEA', 'Bridge of Allan'], ['PEB', 'Pevensey Bay'], ['CRL', 'Chorley'], ['ECS', 'Eccles Road'], ['FSG', 'Fishersgate'], ['YSR', 'Ystrad Rhondda'], ['UNV', 'University (T & W Metro)'], ['WCL', 'West Calder'], ['GNW', 'Greenwich'], ['SAB', 'Smallbrook Junction'], ['BDA', 'Brundall'], ['LNG', 'Longcross'], ['PSW', 'Polesworth'], ['SPP', 'Shippea Hill'], ['FIL', 'Filey'], ['HRR', 'Harrington'], ['MGM', 'Metheringham'], ['RAV', 'Ravenglass for Eskdale'], ['OLT', 'Olton'], ['CRD', 'Chester Road'], ['SAH', 'Salhouse'], ['GIL', 'Gillingham (Dorset)'], ['GNT', 'Gunton'], ['FEN', 'Fenny Stratford'], ['CBB', 'Carbis Bay'], ['BLW', 'Bulwell'], ['FMR', 'Falmer'], ['WNY', 'White Notley'], ['SFD', 'Salford Central'], ['BGI', 'Bargeddie'], ['WLY', 'Woodley'], ['BYC', 'Betws-y-Coed'], ['WYT', 'Wythall'], ['KID', 'Kidderminster'], ['SMO', 'South Merton'], ['ULC', 'Ulceby'], ['AWK', 'Adwick'], ['CRR', 'Corrour'], ['OVR', 'Overton'], ['RET', 'Retford'], ['STQ', 'Southampton Town Quay (Bus)'], ['BBS', 'Bordesley'], ['GOS', 'Grange-over-Sands'], ['MAY', 'Maybole'], ['YET', 'Yetminster'], ['LIH', 'Leigh (Kent)'], ['SMC', 'Sampford Courtenay'], ['SLO', 'Slough'], ['LHE', 'Loch Eil Outward Bound'], ['WBP', 'West Brompton'], ['NBT', 'Norbiton'], ['KVP', 'Kiveton Park'], ['PNL', 'Pannal'], ['MEO', 'Meols'], ['SRG', 'Seer Green'], ['CTO', 'Carlton'], ['GLY', 'Glynde'], ['MSW', 'Mansfield Woodhouse'], ['IBM', 'IBM'], ['BRL', 'Barrhill'], ['TRD', 'Troed-y-rhiw'], ['MEC', 'Meols Cop'], ['POL', 'Polsloe Bridge'], ['TPN', 'Ton Pentre'], ['BCK', 'Buckley'], ['CHC', 'Charing Cross (Glasgow)'], ['SRA', 'Stratford (London)'], ['WWO', 'West Worthing'], ['RSH', 'Rose Hill Marple'], ['SMT', 'St Margarets (Hertfordshire)'], ['WIH', 'Winchmore Hill'], ['CRS', 'Carstairs'], ['KGX', 'London Kings Cross'], ['LHS', 'Limehouse'], ['THB', 'Thornliebank'], ['DRT', 'Darton'], ['LLD', 'Llandudno'], ['NRN', 'Nairn'], ['KGE', 'Kingsknowe'], ['TNA', 'Thornton Abbey'], ['LRD', 'London Road (Guildford)'], ['BAL', 'Balham'], ['FRH', 'Calais Frethun'], ['WAC', 'Warrington Central'], ['GMV', 'Great Malvern'], ['MNC', 'Markinch'], ['WRT', 'Worstead'], ['EBB', 'Ebbw Vale Town'], ['MEL', 'Meldreth'], ['BYB', 'Blythe Bridge'], ['LOT', 'Lostock'], ['CNM', 'Cheltenham Spa'], ['FZH', 'Frizinghall'], ['LLJ', 'Llandudno Junction'], ['UPM', 'Upminster'], ['DBC', 'Dumbarton Central'], ['STT', 'Stewarton'], ['DBE', 'Dumbarton East'], ['TYS', 'Tyseley'], ['DNS', 'Dinas Powys'], ['DEE', 'Dundee'], ['LDY', 'Ladybank'], ['PBY', 'Pembrey & Burry Port'], ['GMD', 'Grimsby Docks'], ['KEI', 'Keighley'], ['BIP', 'Bishopstone'], ['SFO', 'Stanford-le-Hope'], ['BYF', 'Broughty Ferry'], ['MYH', 'Maryhill'], ['DRM', 'Drem'], ['NBE', 'Newbridge'], ['WSF', 'Winsford'], ['THD', 'Thames Ditton'], ['HMM', 'Hammerton'], ['HOR', 'Horley'], ['BLY', 'Bletchley'], ['ARU', 'Arundel'], ['FNB', 'Farnborough (Main)'], ['CGW', 'Caergwrle'], ['MAO', 'Martins Heron'], ['OXT', 'Oxted'], ['PAT', 'Patricroft'], ['GMB', 'Grimsby Town'], ['TUR', 'Turkey Street'], ['TAF', 'Taffs Well'], ['LTN', 'Luton Airport Parkway'], ['CHM', 'Chelmsford'], ['FLW', 'Fulwell'], ['HTW', 'Hartwood'], ['PNZ', 'Penzance'], ['WDE', 'Wood End'], ['GCW', 'Glan Conwy'], ['HOV', 'Hove'], ['TRH', 'Trehafod'], ['WTE', 'Whitlocks End'], ['DLJ', 'Dalston Junction'], ['VIR', 'Virginia Water'], ['ASP', 'Aspatria'], ['LPT', 'Longport'], ['LWS', 'Lewes'], ['EWD', 'Earlswood (West Midlands)'], ['WAN', 'Wanborough'], ['BTO', 'Betchworth'], ['FLN', 'Flint'], ['BUK', 'Bucknell'], ['LLM', 'Llangammarch'], ['CNG', 'Congleton'], ['WMN', 'Warminster'], ['MTL', 'Mortlake'], ['BWT', 'Bridgwater'], ['BRT', 'Barlaston'], ['MNP', 'Manor Park'], ['ESL', 'Eastleigh'], ['SHO', 'Sholing'], ['EGT', 'Egton'], ['HDH', 'Hampstead Heath'], ['WCP', 'Worcester Park'], ['ISP', 'Islip'], ['TPB', 'Thorpe Bay'], ['CRH', 'Crouch Hill'], ['TBW', 'Tunbridge Wells'], ['GLE', 'Gleneagles'], ['KSW', 'Kirkby Stephen'], ['ALW', 'Allens West'], ['DMG', 'Dinas Rhondda'], ['BSR', 'Broadstairs'], ['WEM', 'Wem'], ['CSN', 'Chessington North'], ['HRD', 'Harling Road'], ['AUI', 'Ardlui'], ['ERI', 'Eridge'], ['APD', 'Appledore (Kent)'], ['DHN', 'Deighton'], ['GLG', 'Glengarnock'], ['MLH', 'Mill Hill (Lancashire)'], ['WRP', 'Warwick Parkway'], ['GOF', 'Golf Street'], ['CHY', 'Chertsey'], ['WOK', 'Woking'], ['LLE', 'Llanelli'], ['MYB', 'London Marylebone'], ['WIL', 'Willington'], ['WIJ', 'Willesden Junction'], ['BME', 'Broome'], ['CAM', 'Camberley'], ['SRT', 'Shortlands'], ['SOP', 'Southport'], ['TYB', 'Tan-y-Bwlch  (Bus)'], ['ENC', 'Enfield Chase'], ['RYP', 'Ryde Pier Head'], ['BEB', 'Bebington'], ['LGW', 'Langwathby'], ['WSE', 'Winchelsea'], ['BFR', 'London Blackfriars'], ['SCT', 'Scotscalder'], ['RUG', 'Rugby'], ['SRS', 'Selhurst'], ['MLF', 'Milford (Surrey)'], ['PNA', 'Penally'], ['STU', 'Sturry'], ['TWB', 'Tweedbank'], ['YSM', 'Ystrad Mynach'], ['JEQ', 'Jewellery Quarter'], ['PTW', 'Prestwick Town'], ['EBK', 'Eastbrook'], ['PER', 'Penrhiwceiber'], ['CWM', 'Cwmbran'], ['ING', 'Invergowrie'], ['RBS', 'British Steel Redcar'], ['HLG', 'Hall Green'], ['LSN', 'Livingston North'], ['RML', 'Romiley'], ['BUU', 'Burnham-on-Crouch'], ['ZBC', 'Barons Court Underground'], ['CPN', 'Chapleton'], ['ROG', 'Rogart'], ['LVG', 'Livingston South'], ['HTC', 'Heaton Chapel'], ['KGN', 'Kings Nympton'], ['LCC', 'Lochluichart'], ['DCG', 'Duncraig'], ['TOD', 'Todmorden'], ['WEA', 'West Ealing'], ['SOK', 'South Kenton'], ['SLA', 'Slateford'], ['HLC', 'Helensburgh Central'], ['LGJ', 'Loughborough Junction'], ['HED', 'Halewood'], ['ATH', 'Atherstone'], ['EYN', 'Eynsford'], ['SOT', 'Stoke-on-Trent'], ['CAC', 'Caldercruix'], ['SRC', 'Streatham Common'], ['MSO', 'Moston'], ['BEU', 'Beaulieu Road'], ['ZBK', 'Barking Underground'], ['BNR', 'Brockley Whins (T & W Metro)'], ['LOH', 'Lostock Hall'], ['MIL', 'Mill Hill Broadway'], ['OHL', 'Old Hill'], ['BDW', 'Bedwyn'], ['PMA', 'Portsmouth Arms'], ['WHC', 'Walthamstow Central'], ['KDY', 'Kirkcaldy'], ['FAZ', 'Fazakerley'], ['GLC', 'Glasgow Central'], ['HLU', 'Helensburgh Upper'], ['LTG', 'Lostock Gralam'], ['DLK', 'Dalston Kingsland'], ['MTN', 'Moreton (Dorset)'], ['EBL', 'East Boldon (T & W Metro)'], ['CYN', 'Cynghordy'], ['CHT', 'Chathill'], ['HPT', 'Hopton Heath'], ['ALO', 'Alloa'], ['PMS', 'Portsmouth & Southsea'], ['CON', 'Connel Ferry'], ['WNC', 'Windsor & Eton Central'], ['BET', 'Bethnal Green'], ['SST', 'Stansted Mountfitchet'], ['ESH', 'Esher'], ['WSE', 'Winchelsea'], ['CSS', 'Chessington South'], ['CSL', 'Codsall'], ['CPA', 'Corpach'], ['HGF', 'Hag Fold'], ['SRD', 'Stapleton Road'], ['UPM', 'Upminster'], ['BSJ', 'Bedford St Johns'], ['RYB', 'Roy Bridge'], ['DMP', 'Dumpton Park'], ['LYT', 'Lymington Town'], ['WHE', 'Whalley'], ['HKC', 'Hackney Central'], ['HYC', 'Hyde Central'], ['PEW', 'Pewsey'], ['AHN', 'Ashton-under-Lyne'], ['PRW', 'Perranwell'], ['CKL', 'Corkickle'], ['DOD', 'Dodworth'], ['WTA', 'Wester Hailes'], ['PAW', 'Pelaw (T & W Metro)'], ['AYP', 'Albany Park'], ['NEW', 'Newcraighall'], ['ORE', 'Ore'], ['HAS', 'Halesworth'], ['KWG', 'Kew Gardens'], ['EXG', 'Exhibition Centre'], ['HIL', 'Hillside'], ['MPL', 'Marple'], ['SDA', 'Snodland'], ['BKA', 'Bookham'], ['BNT', 'Brinnington'], ['HKW', 'Hackney Wick'], ['ACR', 'Accrington'], ['QRP', 'Queens Road Peckham'], ['MDG', 'Midgham'], ['BAW', 'Blackwater'], ['MEX', 'Mexborough'], ['ADK', 'Ardwick'], ['DNY', 'Danby'], ['HIN', 'Hindley'], ['PYG', 'Paisley Gilmour Street'], ['PRA', 'Prestwick Intl Airport'], ['DDP', 'Dudley Port'], ['NMK', 'Newmarket'], ['KGL', 'Kings Langley'], ['MLN', 'Milngavie'], ['FML', 'Frimley'], ['NTR', 'Northallerton'], ['SDW', 'Sandwich'], ['BBW', 'Berry Brow'], ['DID', 'Didcot Parkway'], ['SOG', 'Stonegate'], ['HAI', 'Halling'], ['PWL', 'Pwllheli'], ['WCF', 'Westcliff'], ['HGG', 'Haggerston'], ['CMR', 'Cromer'], ['ALX', 'Alexandria'], ['COO', 'Cookham'], ['MRS', 'Monks Risborough'], ['YRT', 'Yorton'], ['BEN', 'Bentham'], ['GOB', 'Gobowen'], ['HAL', 'Hale'], ['CAY', 'Carntyne'], ['BUI', 'Burnside'], ['SEL', 'Sellafield'], ['WIM', 'Wimbledon'], ['YRD', 'Yardley Wood'], ['CHN', 'Cheshunt'], ['HFX', 'Halifax'], ['ELD', 'Earlswood (Surrey)'], ['TOK', 'Three Oaks'], ['PBN', 'Paris Nord'], ['TED', 'Teddington'], ['HKM', 'Hykeham'], ['GRS', 'Garscadden'], ['DSL', 'Disley'], ['HDE', 'Hedge End'], ['BNP', 'Barnstaple'], ['KNS', 'Kennishead'], ['LAK', 'Lakenheath'], ['TUH', 'Tulse Hill'], ['BSY', 'Brondesbury'], ['FOX', 'Foxfield'], ['SHR', 'Shrewsbury'], ['WMG', 'Welham Green'], ['HLF', 'Hillfoot'], ['PMR', 'Peckham Rye'], ['SGR', 'Slade Green'], ['FRE', 'Freshfield'], ['SDG', 'Sandling'], ['DMR', 'Dalmuir'], ['TRF', 'Trefforest'], ['LZB', 'Lazonby & Kirkoswald'], ['KCK', 'Knockholt'], ['LLW', 'Llwyngwril'], ['DCT', 'Danescourt'], ['HRM', 'Harrietsham'], ['WCM', 'Wickham Market'], ['FEA', 'Featherstone'], ['HNH', 'Herne Hill'], ['MCO', 'Manchester Oxford Road'], ['LER', 'Leytonstone High Road'], ['RAU', 'Rauceby'], ['HMW', 'Hampton Wick'], ['SJS', 'St James Street'], ['TEA', 'Tees-side Airport'], ['LNR', 'Llanwrda'], ['BEE', 'Beeston'], ['MTV', 'Mount Vernon'], ['BSV', 'Buckshaw Parkway'], ['DAL', 'Dalmally'], ['KTN', 'Kentish Town'], ['TRA', 'Trafford Park'], ['AMB', 'Ambergate'], ['GOX', 'Goxhill'], ['PLT', 'Pontlottyn'], ['ATT', 'Attadale'], ['POK', 'Pokesdown'], ['STI', 'Stadium of Light (T & W Metro)'], ['HOO', 'Hooton'], ['KGS', 'Kings Sutton'], ['KTW', 'Kentish Town West'], ['ZPC', 'Piccadilly Circus Underground'], ['UTT', 'Uttoxeter'], ['BLH', 'Bellshill'], ['BGA', 'Brundall Gardens'], ['PRT', 'Prestatyn'], ['CPT', 'Clapton'], ['LET', 'Letchworth Garden City'], ['PSN', 'Parson Street'], ['PNE', 'Penge East'], ['NFD', 'Northfield'], ['LTV', 'Lichfield Trent Valley'], ['CBG', 'Cambridge'], ['NPD', 'New Pudsey'], ['ETL', 'East Tilbury'], ['LTV', 'Lichfield Trent Valley'], ['SNI', 'Snaith'], ['AVN', 'Avonmouth'], ['TEN', 'Tenby'], ['PTG', 'Port Glasgow'], ['SPF', 'Springfield'], ['TBD', 'Three Bridges'], ['SLD', 'Salford Crescent'], ['GOE', 'Goldthorpe'], ['SMY', 'St Mary Cray'], ['DBY', 'Derby'], ['HXX', 'Heathrow Airport T123'], ['THO', 'Thornford'], ['PRE', 'Preston'], ['KWN', 'Kilwinning'], ['PRE', 'Preston'], ['HWH', 'Haltwhistle'], ['CNN', 'Canonbury'], ['BOH', 'Bosham'], ['OPK', 'Orrell Park'], ['BDB', 'Broadbottom'], ['LCK', 'Lockwood'], ['NFL', 'Northfleet'], ['TNP', 'Tonypandy'], ['FOC', 'Falls of Cruachan'], ['HYM', 'Haymarket'], ['HIT', 'Hitchin'], ['CLE', 'Cleethorpes'], ['PAL', 'Palmers Green'], ['ARD', 'Ardgay'], ['BUS', 'Busby'], ['LGE', 'Long Eaton'], ['TUL', 'Tulloch'], ['ABD', 'Aberdeen'], ['BRO', 'Bridge of Orchy'], ['GCT', 'Great Coates'], ['INE', 'Ince & Elton'], ['WTT', 'Witton'], ['TRS', 'Thurston'], ['FNC', 'Farncombe'], ['EBD', 'Ebbsfleet International'], ['DUR', 'Durrington-on-Sea'], ['CSA', 'Cosham'], ['PEG', 'Pegswood'], ['CEA', 'Cleland'], ['GCR', 'Gloucester'], ['TAC', 'Tackley'], ['MFH', 'Milford Haven'], ['PRY', 'Perry Barr'], ['RHL', 'Rhyl'], ['THW', 'The Hawthorns'], ['WTH', 'Whitehaven'], ['KNG', 'Kingston'], ['MIK', 'Micklefield'], ['LRG', 'Lairg'], ['EPS', 'Epsom'], ['WBQ', 'Warrington Bank Quay'], ['CUW', 'Clunderwen'], ['DTG', 'Dinting'], ['ACT', 'Ascot'], ['BID', 'Bidston'], ['BWG', 'Bowling'], ['BMP', 'Brampton (Cumbria)'], ['CLT', 'Clacton-on-Sea'], ['BCH', 'Birchington-on-Sea'], ['BEF', 'Benfleet'], ['HMS', 'Helmsdale'], ['KEY', 'Keyham'], ['MOS', 'Moss Side'], ['PTK', 'Partick'], ['SGN', 'South Greenford'], ['SOR', 'Sole Street'], ['DBD', 'Denby Dale'], ['BSP', 'Brondesbury Park'], ['SEE', 'Southease'], ['CNR', 'Crianlarich'], ['CRT', 'Chartham'], ['SUG', 'Sugar Loaf'], ['HGM', 'Higham'], ['WNG', 'Waun-gron Park'], ['DUM', 'Dumbreck'], ['PMR', 'Peckham Rye'], ['CRB', 'Corbridge'], ['NFA', 'North Fambridge'], ['AGV', 'Abergavenny'], ['HAG', 'Hagley'], ['CEL', 'Chelford'], ['HGD', 'Hungerford'], ['BWN', 'Bloxwich North'], ['KVD', 'Kelvindale'], ['RUS', 'Ruswarp'], ['CLV', 'Claverdon'], ['RNH', 'Rainhill'], ['EWW', 'Ewell West'], ['HHY', 'Highbury & Islington'], ['APP', 'Appleby'], ['HKN', 'Hucknall'], ['MSN', 'Marsden'], ['TPC', 'Thorpe Culvert'], ['EWE', 'Ewell East'], ['GTN', 'Grangetown'], ['LEO', 'Leominster'], ['DOL', 'Dolau'], ['CUH', 'Curriehill'], ['KBK', 'Kents Bank'], ['DPS', 'Dublin Port (Stena)'], ['PAI', 'Pallion (T & W Metro)'], ['MCB', 'Moulsecoomb'], ['NMT', 'Needham Market'], ['WFI', 'Westerfield'], ['SCG', 'Stone Crossing'], ['STR', 'Stranraer'], ['ZWA', 'Waterloo Underground'], ['PIL', 'Pilning'], ['SWD', 'Swinderby'], ['MSK', 'Marske'], ['TRN', 'Troon'], ['WID', 'Widnes'], ['KMS', 'Kemsing'], ['STZ', 'St Peters (T & W Metro)'], ['ANF', 'Ashurst New Forest'], ['WTN', 'Whitton'], ['ANL', 'Anniesland'], ['SCS', 'Starcross'], ['FRB', 'Fairbourne'], ['STK', 'Stockton'], ['BEV', 'Beverley'], ['KKM', 'Kirkham & Wesham'], ['PDW', 'Paddock Wood'], ['CAN', 'Carnoustie'], ['STC', 'Strathcarron'], ['CUF', 'Cuffley'], ['MTP', 'Montpelier'], ['SWM', 'Swanscombe'], ['CBE', 'Canterbury East'], ['DMF', 'Dumfries'], ['HNT', 'Huntly'], ['LLT', 'Llanbister Road'], ['WAT', 'London Waterloo'], ['MEW', 'Maesteg (Ewenny Road)'], ['SUT', 'Sutton Coldfield'], ['LDS', 'Leeds'], ['BNM', 'Burnham'], ['BEL', 'Beauly'], ['HXM', 'Hoveton & Wroxham'], ['HDL', 'Headstone Lane'], ['LEY', 'Leyland'], ['PRE', 'Preston'], ['SNY', 'Sunnymeads'], ['RNF', 'Rainford'], ['EGN', 'Eastrington'], ['KGH', 'Kinghorn'], ['MAT', 'Matlock'], ['NCK', 'New Cumnock'], ['NWP', 'Newport (South Wales)'], ['QPW', 'Queens Park (London)'], ['MSD', 'Moorside'], ['WLM', 'Williamwood'], ['DWD', 'Dolwyddelan'], ['WTL', 'Whitland'], ['MPK', 'Mosspark'], ['MAU', 'Mauldeth Road'], ['HEX', 'Hexham'], ['CLI', 'Clifton'], ['SYD', 'Sydenham'], ['LAD', 'Ladywell'], ['CTM', 'Chatham'], ['SWY', 'Sway'], ['TRU', 'Truro'], ['DLY', 'Dalry'], ['PRP', 'Preston Park'], ['BPB', 'Blackpool Pleasure Beach'], ['LHO', 'Langho'], ['SPS', 'Stepps'], ['TOP', 'Topsham'], ['BIA', 'Bishop Auckland'], ['HTH', 'Handforth'], ['MRT', 'Moreton (Merseyside)'], ['MCH', 'March'], ['TDU', 'Tondu'], ['BCS', 'Bicester North'], ['NMP', 'Northampton'], ['ALP', 'Althorpe'], ['BSE', 'Bury St Edmunds'], ['PTR', 'Petersfield'], ['BUC', 'Buckenham'], ['KLY', 'Kenley'], ['ELW', 'Eltham'], ['WHA', 'Westenhanger'], ['WWL', 'Whitwell'], ['EDW', 'East Dulwich'], ['NRD', 'North Road'], ['BTE', 'Bitterne'], ['IMW', 'Imperial Wharf'], ['ANN', 'Annan'], ['BDN', 'Brading'], ['CES', 'Cressing'], ['KBW', 'Knebworth'], ['DAR', 'Darlington'], ['HWD', 'Hawarden'], ['TAD', 'Tadworth'], ['BAG', 'Bagshot'], ['ZHS', 'Kensington High St Underground'], ['SMD', 'Stamford'], ['BUD', 'Burneside'], ['DOT', 'Dunston'], ['ELS', 'Elstree & Borehamwood'], ['CHF', 'Church Fenton'], ['HAZ', 'Hazel Grove'], ['KMH', 'Kempston Hardwick'], ['SOF', 'South Woodham Ferrers'], ['NRW', 'Norwich'], ['AHS', 'Ashurst'], ['FZW', 'Fitzwilliam'], ['MIN', 'Milliken Park'], ['RUN', 'Runcorn'], ['WSL', 'Walsall'], ['OKM', 'Oakham'], ['WAT', 'London Waterloo'], ['AYP', 'Albany Park'], ['MST', 'Maesteg'], ['KNU', 'Knucklas'], ['LEI', 'Leicester'], ['WAT', 'London Waterloo'], ['WCR', 'Whitecraigs'], ['MRP', 'Moorthorpe'], ['SNH', 'St Helens Central'], ['CAO', 'Cannock'], ['RAI', 'Rainham (Kent)'], ['RKT', 'Ruskington'], ['YOK', 'Yoker'], ['BDT', 'Bridlington'], ['LDN', 'Llandanwg'], ['SHJ', 'St Helens Junction'], ['CHH', 'Christs Hospital'], ['CMF', 'Cromford'], ['HYR', 'Haydons Road'], ['LGN', 'Longton'], ['BXH', 'Bexleyheath'], ['CPM', 'Chippenham'], ['DFR', 'Drumfrochar'], ['NCO', 'Newcourt'], ['WET', 'Weeton'], ['EMD', 'East Midlands Parkway'], ['POP', 'Poppleton'], ['AYH', 'Aylesham'], ['ZUM', 'Upminster Underground'], ['CHD', 'Chesterfield'], ['HEZ', 'Heworth (T & W Metro)'], ['PRB', 'Prestbury'], ['GTR', 'Goostrey'], ['ACK', 'Acklington'], ['KNL', 'Kensal Green'], ['SAN', 'Sandown'], ['THL', 'Tile Hill'], ['SIP', 'Shipton'], ['SFA', 'Stratford International'], ['UPW', 'Upwey'], ['GIP', 'Gipsy Hill'], ['RUT', 'Rutherglen'], ['SES', 'South Elmsall'], ['TGM', 'Teignmouth'], ['ADS', 'Ardrossan Harbour'], ['BCG', 'Birchgrove'], ['RFD', 'Rochford'], ['PES', 'Pensarn'], ['BAI', 'Blairhill'], ['TLB', 'Talybont'], ['SVG', 'Stevenage'], ['WPE', 'Wapping'], ['BDG', 'Bridgeton'], ['THH', 'Thatto Heath'], ['ATB', 'Attenborough'], ['MTH', 'Motherwell'], ['WKM', 'Wokingham'], ['GMT', 'Grosmont'], ['ARL', 'Arlesey'], ['BGD', 'Bargoed'], ['REE', 'Reedham (Norfolk)'], ['HPA', 'Honor Oak Park'], ['NUN', 'Nuneaton'], ['TRM', 'Trimley'], ['WTY', 'Witley'], ['SWO', 'Snowdown'], ['MDB', 'Maidstone Barracks'], ['ENL', 'Enfield Lock'], ['MIJ', 'Mitcham Junction'], ['MDE', 'Maidstone East'], ['GOD', 'Godalming'], ['HGR', 'Hither Green'], ['SPO', 'Spondon'], ['WNT', 'Wandsworth Town'], ['ECR', 'East Croydon'], ['CLS', 'Chester-le-Street'], ['QYD', 'Quakers Yard'], ['WBC', 'Waterbeach'], ['NES', 'Neston'], ['PCN', 'Paisley Canal'], ['WSA', 'West Allerton'], ['SFI', 'Shawfair'], ['SLH', 'Sleights'], ['HTN', 'Hatton'], ['KIV', 'Kiveton Bridge'], ['RIS', 'Rishton'], ['DMS', 'Dormans'], ['LCN', 'Lincoln Central'], ['AYP', 'Albany Park'], ['ERI', 'Eridge'], ['WLC', 'Waltham Cross'], ['MPT', 'Morpeth'], ['MDW', 'Maidstone West'], ['WEL', 'Wellingborough'], ['HRY', 'Harringay Green Lanes'], ['MOB', 'Mobberley'], ['SWL', 'Swale'], ['ECC', 'Eccles'], ['HEW', 'Heworth'], ['LLH', 'Llangennech'], ['BKO', 'Brookwood'], ['GSY', 'Guiseley'], ['SBY', 'Selby'], ['WSB', 'Westbury'], ['ETC', 'Etchingham'], ['BLT', 'Blantyre'], ['SSD', 'Stansted Airport'], ['DOR', 'Dore'], ['NVR', 'Navigation Road'], ['CFF', 'Croftfoot'], ['CKN', 'Crewkerne'], ['GLT', 'Glenrothes with Thornton'], ['WTG', 'Watlington'], ['BAN', 'Banbury'], ['HYS', 'Hayes (Kent)'], ['BHR', 'Builth Road'], ['KND', 'Kingswood'], ['KNN', 'Kings Norton'], ['WOL', 'Wolverton'], ['WTO', 'Water Orton'], ['ADR', 'Airdrie'], ['LLC', 'Llandecwyn'], ['PKS', 'Parkstone (Dorset)'], ['GOM', 'Gomshall'], ['TYL', 'Tyndrum Lower'], ['BOP', 'Bowes Park'], ['HRY', 'Harringay Green Lanes'], ['HER', 'Hersham'], ['WRH', 'Worthing'], ['BON', 'Bolton'], ['BOA', 'Bradford-on-Avon'], ['CFH', 'Chafford Hundred'], ['UTY', 'Upper Tyndrum'], ['NAR', 'Narberth'], ['BDL', 'Birkdale'], ['HMT', 'Ham Street'], ['MKM', 'Melksham'], ['AUW', 'Ascott-under-Wychwood'], ['EAL', 'Ealing Broadway'], ['EAL', 'Ealing Broadway'], ['WTB', 'Whitby'], ['CST', 'London Cannon Street'], ['DWN', 'Darwen'], ['BLE', 'Bramley (West Yorkshire)'], ['AAP', 'Alexandra Palace'], ['NUF', 'Nutfield'], ['STG', 'Stirling'], ['HON', 'Honiton'], ['BPW', 'Bristol Parkway'], ['KIT', 'Kintbury'], ['RAD', 'Radley'], ['MCE', 'Metro Centre'], ['SNT', 'Stanlow & Thornton'], ['BYD', 'Barry Docks'], ['DAM', 'Dalmeny'], ['FIN', 'Finstock'], ['BMT', 'Bedminster'], ['HSL', 'Haslemere'], ['CET', 'Colchester Town'], ['HDG', 'Heald Green'], ['PNR', 'Penrith'], ['MHM', 'Merstham'], ['HSC', 'Hoscar'], ['SNO', 'St Neots'], ['BGM', 'Bellingham'], ['NTL', 'Netley'], ['HYH', 'Hythe'], ['RDC', 'Redditch'], ['LTK', 'Little Kimble'], ['FOD', 'Ford'], ['CLJ', 'Clapham Junction'], ['HON', 'Honiton'], ['CLJ', 'Clapham Junction'], ['PNW', 'Penge West'], ['WFJ', 'Watford Junction'], ['HCH', 'Holmes Chapel'], ['LVN', 'Littlehaven'], ['BTL', 'Batley'], ['ZET', 'Earl\'s Court Underground'], ['WDL', 'Woodhall'], ['BLX', 'Bloxwich'], ['HLS', 'Hilsea'], ['MKT', 'Marks Tey'], ['OKE', 'Okehampton'], ['HWY', 'High Wycombe'], ['SYT', 'Somerleyton'], ['MRY', 'Maryport'], ['SDY', 'Sandy'], ['CLJ', 'Clapham Junction'], ['CEF', 'Chapel-en-le-Frith'], ['LTP', 'Littleport'], ['KPT', 'Kilpatrick'], ['WDD', 'Widdrington'], ['WHM', 'Whimple'], ['CIT', 'Chislehurst'], ['PFR', 'Pontefract Baghill'], ['BKC', 'Birkenhead Central'], ['HOY', 'Honley'], ['INC', 'Ince'], ['CLJ', 'Clapham Junction'], ['GRC', 'Great Chesterford'], ['IPS', 'Ipswich'], ['WCB', 'Westcombe Park'], ['CLJ', 'Clapham Junction'], ['LYP', 'Lymington Pier'], ['CTF', 'Catford'], ['CTE', 'Chatelherault'], ['FWY', 'Five Ways'], ['NDL', 'North Dulwich'], ['BWO', 'Bricket Wood'], ['BKN', 'Birkenhead North'], ['SOW', 'Sowerby Bridge'], ['BTY', 'Bentley (Hampshire)'], ['KLD', 'Kildale'], ['NQY', 'Newquay'], ['SCA', 'Scarborough'], ['BEG', 'Beltring'], ['BKP', 'Birkenhead Park'], ['CLJ', 'Clapham Junction'], ['GLO', 'Glossop'], ['GRH', 'Gartcosh'], ['TUT', 'Tutbury & Hatton'], ['BCE', 'Bracknell'], ['NNT', 'Nunthorpe'], ['ZNP', 'Newbury Park Underground'], ['SND', 'Sandhurst'], ['FSB', 'Fishbourne (West Sussex)'], ['SLW', 'Salwick'], ['DIG', 'Digby & Sowton'], ['EDG', 'Edge Hill'], ['INH', 'Invershin'], ['BTB', 'Barnetby'], ['SJN', 'St James (T & W Metro)'], ['SUY', 'Sudbury'], ['AIG', 'Aigburth'], ['ELR', 'Elsecar'], ['SGB', 'Smethwick Galton Bridge'], ['HYL', 'Hayle'], ['KEM', 'Kemble'], ['WIM', 'Wimbledon'], ['SAS', 'St Annes-on-the-Sea'], ['SHM', 'Sheringham'], ['WRL', 'Wetheral'], ['SUP', 'Sundridge Park'], ['AWM', 'Ashwell & Morden'], ['BUY', 'Burley Park'], ['ABA', 'Aberdare'], ['CRO', 'Croy'], ['DAT', 'Datchet'], ['LGS', 'Langside'], ['WDM', 'Windermere'], ['GMY', 'Goodmayes'], ['BDQ', 'Bradford Forster Square'], ['SOH', 'South Hampstead'], ['GPK', 'Grange Park'], ['EDP', 'Edinburgh Park'], ['NWB', 'North Wembley'], ['NWE', 'Newport (Essex)'], ['CYT', 'Cherry Tree'], ['HUY', 'Huyton'], ['SFN', 'Shifnal'], ['TOM', 'Tottenham Hale'], ['CDI', 'Crediton'], ['HUT', 'Hutton Cranswick'], ['ABW', 'Abbey Wood'], ['GDL', 'Godley'], ['RHD', 'Ribblehead'], ['TYP', 'Tynemouth (T & W Metro)'], ['CSO', 'Croston'], ['PHR', 'Penshurst'], ['LAC', 'Lancing'], ['SWS', 'South Wigston'], ['BUX', 'Buxton'], ['MLD', 'Mouldsworth'], ['FLE', 'Fleet'], ['MKR', 'Market Rasen'], ['LEG', 'Lea Green'], ['CMH', 'Cwmbach'], ['TMC', 'Templecombe'], ['TWI', 'Twickenham'], ['WEE', 'Weeley'], ['HID', 'Hall I\' Th\' Wood'], ['TTF', 'Thetford'], ['DLH', 'Doleham'], ['BTF', 'Bottesford'], ['JOR', 'Jordanhill'], ['TIL', 'Tilbury Town'], ['BMR', 'Bromborough Rake'], ['DPD', 'Dorking Deepdene'], ['BUT', 'Burton-on-Trent'], ['LEO', 'Leominster'], ['FRN', 'Fearn'], ['SPK', 'Sutton Parkway'], ['STL', 'Southall'], ['VXH', 'Vauxhall'], ['ALM', 'Alnmouth'], ['HMN', 'Homerton'], ['PNS', 'Penistone'], ['DFP', 'Dublin Ferryport'], ['SED', 'Shelford'], ['MLB', 'Millbrook (Bedfordshire)'], ['WWR', 'Wandsworth Road'], ['WBR', 'Whaley Bridge'], ['CNS', 'Conisbrough'], ['JHN', 'Johnstone'], ['LND', 'Longniddry'], ['STF', 'Stromeferry'], ['BCN', 'Branchton'], ['PET', 'Petts Wood'], ['RSG', 'Rose Grove'], ['SAM', 'Saltmarshe'], ['BNS', 'Barnes'], ['PKG', 'Penkridge'], ['SGB', 'Smethwick Galton Bridge'], ['MUF', 'Manchester United FC'], ['RHY', 'Rhymney'], ['AMR', 'Amersham'], ['KDB', 'Kidbrooke'], ['PLC', 'Pluckley'], ['CSM', 'Castleton Moor'], ['HWF', 'Heathrow Airport T4 (Bus)'], ['TAD', 'Tadworth'], ['GTY', 'Gatley'], ['HWX', 'Heathrow Airport T5 (Bus)'], ['BLK', 'Blackrod'], ['SLK', 'Silkstone Common'], ['BSB', 'Bleasby'], ['AGS', 'Argyle Street'], ['MUI', 'Muirend'], ['SMG', 'St Margarets (London)'], ['MAN', 'Manchester Piccadilly'], ['SEG', 'Selling'], ['PLN', 'Portlethen'], ['BSM', 'Branksome'], ['NLN', 'New Lane'], ['HTO', 'Hightown'], ['BYI', 'Barry Island'], ['HOL', 'Holton Heath'], ['SFL', 'Seaforth & Litherland'], ['SBR', 'Spean Bridge'], ['KGS', 'Kings Sutton'], ['LRB', 'London Road (Brighton)'], ['GSC', 'Gilshochill'], ['MCM', 'Morecambe'], ['STP', 'London St Pancras (Intl)'], ['FGT', 'Faygate'], ['ALD', 'Alderley Edge'], ['COH', 'Crowborough'], ['ANF', 'Ashurst New Forest'], ['OCK', 'Ockendon'], ['ASN', 'Addlestone'], ['CLL', 'Collington'], ['MOT', 'Motspur Park'], ['SDL', 'Sandhills'], ['KKB', 'Kirkby in Ashfield'], ['PAD', 'London Paddington'], ['WOB', 'Woburn Sands'], ['BNI', 'Barnes Bridge'], ['QPW', 'Queens Park (London)'], ['BNY', 'Barnsley'], ['BPN', 'Blackpool North'], ['KWD', 'Kirkwood'], ['SCH', 'Scotstounhill'], ['KNT', 'Kenton'], ['LHD', 'Leatherhead'], ['DRO', 'Dronfield'], ['MRD', 'Morchard Road'], ['CHU', 'Cheadle Hulme'], ['LIC', 'Lichfield City'], ['DSM', 'Darsham'], ['ENF', 'Enfield Town'], ['SSE', 'Shoreham-by-Sea'], ['LGF', 'Longfield'], ['LIP', 'Liphook'], ['ACC', 'Acton Central'], ['NHE', 'New Hythe'], ['GCH', 'Garelochhead'], ['GSN', 'Garston (Hertfordshire)'], ['WRY', 'Wraysbury'], ['RID', 'Ridgmont'], ['KNF', 'Knutsford'], ['STN', 'Stonehaven'], ['WHP', 'West Hampstead Thameslink'], ['DIS', 'Diss'], ['MLG', 'Mallaig'], ['REI', 'Reigate'], ['DNG', 'Dunton Green'], ['LUX', 'Luxulyan'], ['GFD', 'Greenford'], ['GNR', 'Green Road'], ['STH', 'Shepreth'], ['BXW', 'Boxhill & Westhumble'], ['DUD', 'Duddeston'], ['FER', 'Fernhill'], ['CHI', 'Chingford'], ['BKQ', 'Hamilton Square'], ['MUB', 'Musselburgh'], ['ULL', 'Ulleskelf'], ['CLP', 'Clapham High Street'], ['COW', 'Cowdenbeath'], ['GLH', 'Glasshoughton'], ['ATL', 'Attleborough'], ['BIN', 'Bingham'], ['LGO', 'Llangynllo'], ['LRB', 'London Road (Brighton)'], ['WKD', 'Walkden'], ['HRW', 'Harrow & Wealdstone'], ['URM', 'Urmston'], ['CUA', 'Culrain'], ['NBW', 'North Berwick'], ['DMC', 'Drumchapel'], ['EMP', 'Emerson Park'], ['HLE', 'Hillington East'], ['MGN', 'Marston Green'], ['UWL', 'Upper Warlingham'], ['LWM', 'Llantwit Major'], ['ZDE', 'Dagenham East Underground'], ['HIB', 'High Brooms'], ['TQY', 'Torquay'], ['LEU', 'Leuchars'], ['LST', 'London Liverpool Street'], ['ZTG', 'Turnham Green Underground'], ['CDY', 'Cartsdyke'], ['MTC', 'Mitcham Eastfields'], ['HVF', 'Haverfordwest'], ['CSW', 'Chestfield & Swalecliffe'], ['TIR', 'Tir-phil'], ['ERL', 'Earlestown'], ['BGL', 'Bugle'], ['HWM', 'Harlow Mill'], ['SYB', 'Stalybridge'], ['NOA', 'Newton-on-Ayr'], ['FRT', 'Frant'], ['GUI', 'Guide Bridge'], ['HLW', 'Hillington West'], ['MYT', 'Mytholmroyd'], ['BKM', 'Berkhamsted'], ['NEL', 'Nelson'], ['NLT', 'Northolt Park'], ['BES', 'Bescar Lane'], ['BNA', 'Burnage'], ['SRY', 'Shoeburyness'], ['MSR', 'Minster'], ['BNH', 'Barnehurst'], ['DUN', 'Dunbar'], ['LLG', 'Llangadog'], ['PIN', 'Pinhoe'], ['POR', 'Porth'], ['CTR', 'Chester'], ['MCK', 'Marne La Vallee'], ['BUO', 'Bursledon'], ['MDL', 'Middlewood'], ['RHM', 'Reedham (Surrey)'], ['WHD', 'West Hampstead'], ['BDH', 'Bedhampton'], ['ROB', 'Roby'], ['KBF', 'Kirkby-in-Furness'], ['RTR', 'Rochester'], ['STV', 'Stevenston'], ['TIP', 'Tipton'], ['ASB', 'Ardrossan South Beach'], ['DBR', 'Derby Road'], ['LMS', 'Leamington Spa'], ['FSK', 'Fiskerton'], ['HWI', 'Horwich Parkway'], ['WLI', 'Welling'], ['WGC', 'Welwyn Garden City'], ['SOU', 'Southampton Central'], ['RUE', 'Runcorn East'], ['FNH', 'Farnham'], ['SRI', 'Spring Road'], ['TAU', 'Taunton'], ['ALT', 'Altrincham'], ['WDS', 'Woodlesford'], ['LEL', 'Lelant'], ['MNR', 'Manor Road'], ['PPL', 'Pontypool & New Inn'], ['RDG', 'Reading'], ['WNR', 'Windsor & Eton Riverside'], ['SWT', 'Slaithwaite'], ['RCD', 'Rochdale'], ['CYP', 'Crystal Palace'], ['DDG', 'Dorridge'], ['KBX', 'Kirby Cross'], ['SBJ', 'Stourbridge Junction'], ['CRI', 'Cricklewood'], ['WDU', 'West Dulwich'], ['SNN', 'Swinton (Manchester)'], ['BRP', 'Brampton (Suffolk)'], ['COV', 'Coventry'], ['DGL', 'Dingle Road'], ['PYC', 'Pontyclun'], ['LNY', 'Langley'], ['GRP', 'Grove Park'], ['HOU', 'Hounslow'], ['SAE', 'Saltaire'], ['BEH', 'Bedworth'], ['SCY', 'South Croydon'], ['BCY', 'Brockley'], ['AVI', 'Avignon'], ['VIC', 'London Victoria'], ['BWD', 'Birchwood'], ['HWN', 'Harlow Town'], ['VIC', 'London Victoria'], ['FRO', 'Frome'], ['VIC', 'London Victoria'], ['AWT', 'Armathwaite'], ['CAT', 'Caterham'], ['COB', 'Cooden Beach'], ['WVH', 'Wolverhampton'], ['HME', 'Hamble'], ['AUG', 'Aughton Park'], ['BEX', 'Bexhill'], ['ACY', 'Abercynon'], ['CML', 'Carmyle'], ['PBR', 'Potters Bar'], ['TOL', 'Tolworth'], ['APN', 'Newcastle Airport'], ['ADN', 'Ardrossan Town'], ['GDP', 'Gidea Park'], ['SBJ', 'Stourbridge Junction'], ['WIJ', 'Willesden Junction'], ['SDM', 'Shieldmuir'], ['SEV', 'Sevenoaks'], ['FRM', 'Fareham'], ['HNA', 'Hinton Admiral'], ['MRN', 'Marden'], ['MIA', 'Manchester Airport'], ['SBT', 'Stourbridge Town'], ['MAI', 'Maidenhead'], ['BKH', 'Blackheath'], ['BYS', 'Braystones'], ['HGT', 'Harrogate'], ['BIL', 'Billingham'], ['STM', 'St Michaels'], ['BVD', 'Belvedere'], ['LTS', 'Lelant Saltings'], ['LHA', 'Loch Awe'], ['BAD', 'Banstead'], ['INT', 'Ingatestone'], ['MKC', 'Milton Keynes Central'], ['EDR', 'Edmonton Green'], ['BNV', 'Banavie'], ['BTP', 'Braintree Freeport'], ['ROC', 'Roche'], ['CHP', 'Chipstead'], ['FNW', 'Farnworth'], ['TAI', 'Tain'], ['GAL', 'Galashiels'], ['CHG', 'Charing'], ['RMD', 'Richmond'], ['MTN', 'Moreton (Dorset)'], ['COR', 'Corby'], ['SOI', 'Stow'], ['BLG', 'Bellgrove'], ['CNF', 'Carnforth'], ['PST', 'Prestonpans'], ['PKT', 'Park Street'], ['SKS', 'Stocksfield'], ['NRC', 'Newbury Racecourse'], ['PNY', 'Pen-y-bont'], ['EKL', 'East Kilbride'], ['SRU', 'South Ruislip'], ['CDU', 'Cam & Dursley'], ['BRV', 'Bournville'], ['WMS', 'Wemyss Bay'], ['UDD', 'Uddingston'], ['BHD', 'Brithdir'], ['MOR', 'Mortimer'], ['CUM', 'Culham'], ['SDH', 'Sudbury Hill Harrow'], ['STA', 'Stafford'], ['PRL', 'Prittlewell'], ['RDT', 'Radlett'], ['SHP', 'Shepperton'], ['CNP', 'Conway Park'], ['TLK', 'The Lakes'], ['BRX', 'Brixton'], ['MTB', 'Matlock Bath'], ['CLN', 'Chapeltown'], ['KYN', 'Keynsham'], ['NWA', 'North Walsham'], ['BYA', 'Berney Arms'], ['REC', 'Rectory Road'], ['RRB', 'Ryder Brow'], ['SUD', 'Sudbury & Harrow Road'], ['SMN', 'Southminster'], ['YAT', 'Yatton'], ['KSN', 'Kearsney'], ['PTF', 'Pantyffynnon'], ['SWN', 'Swinton (South Yorkshire)'], ['SRN', 'Strines'], ['SWA', 'Swansea'], ['TRR', 'Torre'], ['SSC', 'Seascale'], ['HOT', 'Henley-on-Thames'], ['MVL', 'Malvern Link'], ['ARR', 'Arram'], ['SLT', 'Saltcoats'], ['ANZ', 'Anerley'], ['FPK', 'Finsbury Park'], ['LAN', 'Lancaster'], ['THA', 'Thatcham'], ['BSC', 'Bescot Stadium'], ['MTO', 'Marton'], ['EGG', 'Eggesford'], ['KEH', 'Keith'], ['WCY', 'West Croydon'], ['BOD', 'Bodmin Parkway'], ['HOP', 'Hope (Derbyshire)'], ['HRW', 'Harrow & Wealdstone'], ['WTC', 'Whitchurch (Shropshire)'], ['CHX', 'London Charing Cross'], ['KIR', 'Kirkby'], ['WGA', 'Westgate-on-Sea'], ['WSM', 'Weston-super-Mare'], ['BKS', 'Bekesbourne'], ['AHT', 'Aldershot'], ['DFI', 'Duffield'], ['GIR', 'Girvan'], ['ZBB', 'Barbican Underground'], ['HPE', 'Hope (Flintshire)'], ['CLW', 'Chorleywood'], ['HHL', 'Heath High Level'], ['KKS', 'Kirk Sandall'], ['RDD', 'Riddlesdown'], ['RFY', 'Rock Ferry'], ['ABE', 'Aber'], ['HSK', 'Hassocks'], ['SHT', 'Shotton'], ['LVC', 'Liverpool Central'], ['AIN', 'Aintree'], ['HNG', 'Hengoed'], ['LIS', 'Liss'], ['ARM', 'Armadale'], ['FFA', 'Ffairfach'], ['HCB', 'Hackbridge'], ['LVC', 'Liverpool Central'], ['ELP', 'Ellesmere Port'], ['DYF', 'Dyffryn Ardudwy'], ['TYW', 'Tywyn'], ['CWN', 'Cowden'], ['EGH', 'Egham'], ['RET', 'Retford'], ['HAY', 'Hayes & Harlington'], ['SAT', 'South Acton'], ['PMT', 'Polmont'], ['HPQ', 'Harwich International'], ['WED', 'Wedgwood'], ['BIO', 'Baillieston'], ['WCH', 'Whitchurch (Hampshire)'], ['MNE', 'Manea'], ['SNF', 'Shenfield'], ['ROM', 'Romsey'], ['CHL', 'Chilworth'], ['CDN', 'Coulsdon Town'], ['TLS', 'Thorpe-le-Soken'], ['WRS', 'Wressle'], ['BDY', 'Bredbury'], ['THI', 'Thirsk'], ['WES', 'Westerton'], ['CPU', 'Capenhurst'], ['LRH', 'Larkhall'], ['OLD', 'Old Street'], ['DGT', 'Deansgate'], ['SEM', 'Seamer'], ['SVB', 'Severn Beach'], ['BMC', 'Bromley Cross'], ['SEC', 'Seaton Carew'], ['ZLW', 'Whitechapel'], ['SEE', 'Southease'], ['SOA', 'Southampton Airpt Parkway'], ['WDO', 'Waddon'], ['WTS', 'Whatstandwell'], ['LPY', 'Liverpool South Parkway'], ['HFN', 'Hertford North'], ['KGM', 'Kingham'], ['WFL', 'Wainfleet'], ['SKN', 'St Keyne Wishing Well Halt'], ['DPT', 'Devonport'], ['SOW', 'Sowerby Bridge'], ['WDU', 'West Dulwich'], ['BCB', 'Burscough Bridge'], ['HST', 'High Street'], ['LEM', 'Leyton Midland Road'], ['PYL', 'Pyle'], ['WRU', 'West Ruislip'], ['WYB', 'Weybridge'], ['TAB', 'Tame Bridge Parkway'], ['TRE', 'Trefforest Estate'], ['WYB', 'Weybridge'], ['HND', 'Hanborough'], ['WLW', 'Welwyn North'], ['BMO', 'Birmingham Moor Street'], ['BCJ', 'Burscough Junction'], ['DCW', 'Dorchester West'], ['LVJ', 'James Street'], ['RDF', 'Radcliffe (Nottinghamshire)'], ['CPY', 'Clapham (North Yorkshire)'], ['RMF', 'Romford'], ['SAV', 'Stratford-upon-Avon'], ['LHW', 'Lochwinnoch'], ['NOT', 'Nottingham'], ['CUD', 'Cuddington'], ['LLA', 'Llanaber'], ['SNE', 'Stone'], ['SHL', 'Shawlands'], ['FFD', 'Freshford'], ['SHF', 'Sheffield'], ['YRK', 'York'], ['CSD', 'Cobham & Stoke d\'Abernon'], ['ENT', 'Entwistle'], ['PRN', 'Parton'], ['ROL', 'Rolleston'], ['BRH', 'Borth'], ['BCV', 'Bruce Grove'], ['SMR', 'Smethwick Rolfe Street'], ['ACN', 'Achnasheen'], ['KWB', 'Kew Bridge'], ['SAR', 'St Andrews Road'], ['ASF', 'Ashfield'], ['FLM', 'Flimby'], ['LBT', 'Larbert'], ['WOR', 'Worle'], ['CWL', 'Colwall'], ['EXC', 'Exeter Central'], ['NTB', 'Norton Bridge'], ['TWY', 'Twyford'], ['ROR', 'Rogerstone'], ['BDI', 'Bradford Interchange'], ['WNL', 'Whinhill'], ['BLA', 'Blair Atholl'], ['KML', 'Kemsley'], ['SDR', 'Saunderton'], ['GRK', 'Gourock'], ['VXH', 'Vauxhall'], ['FTW', 'Fort William'], ['LIT', 'Littlehampton'], ['SIV', 'St Ives'], ['BLD', 'Baildon'], ['GLM', 'Gillingham (Kent)'], ['SHS', 'Shotts'], ['UCK', 'Uckfield'], ['BTG', 'Barnt Green'], ['BOM', 'Bromborough'], ['ACH', 'Achnashellach'], ['UHA', 'Uphall'], ['VXH', 'Vauxhall'], ['DIN', 'Dingwall'], ['HDW', 'Hadley Wood'], ['SOB', 'Southbourne'], ['LEE', 'Lee'], ['QBR', 'Queenborough'], ['LOC', 'Lockerbie'], ['SMA', 'Small Heath'], ['WDB', 'Woodbridge'], ['HIR', 'Horton-in-Ribblesdale'], ['PON', 'Ponders End'], ['FRI', 'Frinton-on-Sea'], ['SAL', 'Salisbury'], ['SRH', 'Streatham Hill'], ['CRK', 'Chirk'], ['EXR', 'Essex Road'], ['HOK', 'Hook'], ['SML', 'Sea Mills'], ['HLY', 'Holytown'], ['NWD', 'Norwood Junction'], ['ASY', 'Ashley'], ['ESW', 'Elmswell'], ['HOH', 'Harrow-on-the-Hill'], ['AGR', 'Angel Road'], ['NSD', 'Newstead'], ['HUL', 'Hull'], ['HLL', 'Heath Low Level'], ['PBL', 'Parbold'], ['JOH', 'Johnston'], ['SMB', 'Smithy Bridge'], ['NSH', 'North Sheen'], ['UPL', 'Upholland'], ['BGE', 'Broad Green'], ['CBY', 'Charlbury'], ['WME', 'Woodmansterne'], ['LAR', 'Largs'], ['MMO', 'Melton Mowbray'], ['LIN', 'Linlithgow'], ['WDT', 'West Drayton'], ['HFE', 'Hertford East'], ['KET', 'Kettering'], ['PUL', 'Pulborough'], ['QRB', 'Queenstown Road Battersea'], ['WMB', 'Wembley Central'], ['BRG', 'Borough Green & Wrotham'], ['GEA', 'Gretna Green'], ['KPA', 'Kensington Olympia'], ['CIM', 'Cilmeri'], ['SWR', 'Stewartby'], ['CMO', 'Camelon'], ['GLQ', 'Glasgow Queen Street'], ['BSU', 'Brunstane'], ['IFI', 'Ifield'], ['ARN', 'Arnside'], ['FRW', 'Fairwater'], ['LKE', 'Lake'], ['CTL', 'Cattal'], ['DMH', 'Dilton Marsh'], ['WWD', 'Woolwich Dockyard'], ['BTS', 'Burntisland'], ['HSW', 'Heswall'], ['KEL', 'Kelvedon'], ['DBL', 'Dunblane'], ['NLR', 'North Llanrwst'], ['HUB', 'Hunmanby'], ['SAF', 'Salfords'], ['WNE', 'Wilnecote'], ['QPK', 'Queens Park (Glasgow)'], ['WTM', 'Witham'], ['AVP', 'Aylesbury Vale Parkway'], ['PTD', 'Pontarddulais'], ['RDG', 'Reading'], ['EXM', 'Exmouth'], ['SNW', 'Swanwick'], ['FCN', 'Falconwood'], ['GOO', 'Goole'], ['LBO', 'Loughborough'], ['HSB', 'Helsby'], ['SHD', 'Shildon'], ['TAY', 'Taynuilt'], ['SNS', 'Staines'], ['CBW', 'Canterbury West'], ['EGF', 'East Garforth'], ['AUR', 'Aberdour'], ['DKG', 'Dorking'], ['GAR', 'Garrowhill'], ['HUN', 'Huntingdon'], ['LLY', 'Llwynypia'], ['SAY', 'Swanley'], ['TTH', 'Thornton Heath'], ['LSK', 'Liskeard'], ['LSW', 'Leasowe'], ['PMP', 'Plumpton'], ['WKK', 'Wakefield Kirkgate'], ['RFY', 'Rock Ferry'], ['DDK', 'Dagenham Dock'], ['HPN', 'Hapton'], ['LNB', 'Llanbradach'], ['BAD', 'Banstead'], ['BIT', 'Bicester Village'], ['MBR', 'Middlesbrough'], ['AAT', 'Achanalt'], ['HIP', 'Highams Park'], ['SIN', 'Singer'], ['TYG', 'Tygwyn'], ['CUP', 'Cupar'], ['FKC', 'Folkestone Central'], ['SIL', 'Sileby'], ['ESM', 'Elsenham'], ['EPD', 'Epsom Downs'], ['HBP', 'Hornbeam Park'], ['HOZ', 'Howwood'], ['RFY', 'Rock Ferry'], ['MEP', 'Meopham'], ['SWG', 'Swaythling'], ['AVM', 'Aviemore'], ['BHK', 'Bush Hill Park'], ['PEA', 'Peartree'], ['WNN', 'Wennington'], ['AYL', 'Aylesford'], ['PIT', 'Pitlochry'], ['OVE', 'Overpool'], ['ZCO', 'Croxley Underground'], ['GYM', 'Great Yarmouth'], ['CPK', 'Carpenders Park'], ['GLC', 'Glasgow Central'], ['LAS', 'Llansamlet'], ['SPN', 'Spooner Row'], ['FKW', 'Folkestone West'], ['KBC', 'Kinbrace'], ['AND', 'Anderston'], ['ZCW', 'Canada Water'], ['DON', 'Doncaster'], ['EAR', 'Earley'], ['CTN', 'Charlton'], ['ZFD', 'Farringdon Underground'], ['SBF', 'St Budeaux Ferry Road'], ['PCD', 'Pencoed'], ['LBG', 'London Bridge'], ['MZH', 'Maze Hill'], ['WTI', 'Winnersh Triangle'], ['HPD', 'Harpenden'], ['SHT', 'Shotton'], ['LBG', 'London Bridge'], ['NRT', 'Nethertown'], ['LBG', 'London Bridge'], ['HMY', 'Hairmyres'], ['HHB', 'Heysham Port'], ['PSH', 'Pershore'], ['PAN', 'Pangbourne'], ['CLU', 'Carluke'], ['SOC', 'Southend Central'], ['MFF', 'Minffordd'], ['BRF', 'Brierfield'], ['COT', 'Cottingley'], ['PTB', 'Pentre-bach'], ['SKG', 'Skegness'], ['INS', 'Insch'], ['EXN', 'Exton'], ['LOO', 'Looe'], ['WWA', 'Woolwich Arsenal'], ['CLK', 'Clock House'], ['BPT', 'Bishopton'], ['BAS', 'Bere Alston'], ['LCS', 'Locheilside'], ['MEV', 'Merthyr Vale'], ['BDH', 'Bedhampton'], ['SDE', 'Shadwell'], ['STP', 'London St Pancras (Intl)'], ['WEH', 'West Ham'], ['HUP', 'Humphrey Park'], ['BTO', 'Betchworth'], ['EVE', 'Evesham'], ['SEF', 'Seaford'], ['ALR', 'Alresford'], ['HNL', 'Henley-in-Arden'], ['SRL', 'Shirley'], ['BFF', 'Blaenau Ffestiniog'], ['FNN', 'Farnborough North'], ['NLW', 'Newton-le-Willows'], ['YAL', 'Yalding'], ['BMH', 'Bournemouth'], ['LHM', 'Lealholm'], ['TVP', 'Tiverton Parkway'], ['BIW', 'Biggleswade'], ['WLS', 'Woolston'], ['BIP', 'Bishopstone'], ['EBV', 'Ebbw Vale Parkway'], ['NNG', 'Newark North Gate'], ['PHG', 'Penhelig'], ['MNG', 'Manningtree'], ['TAT', 'Tattenham Corner'], ['MEN', 'Menheniot'], ['FSB', 'Fishbourne (West Sussex)'], ['CNN', 'Canonbury'], ['HRO', 'Harold Wood'], ['BKJ', 'Beckenham Junction'], ['NFN', 'Nafferton'], ['BNO', 'Benton (T & W Metro)'], ['GRV', 'Gravesend'], ['NBY', 'Newbury'], ['SDC', 'Shoreditch High Street'], ['AXP', 'Alexandra Parade'], ['FXN', 'Foxton'], ['MTS', 'Montrose'], ['BTN', 'Brighton'], ['RDG', 'Reading'], ['CIR', 'Caledonian Rd & Barnsbury'], ['TAL', 'Talsarnau'], ['CWN', 'Cowden'], ['NLS', 'Nailsea & Backwell'], ['WNH', 'Warnham'], ['HWB', 'Hawarden Bridge'], ['LLN', 'Llandaf'], ['NRB', 'Norbury'], ['CSY', 'Coseley'], ['LLL', 'Llandeilo'], ['RIC', 'Rickmansworth'], ['WMB', 'Wembley Central'], ['ADV', 'Andover'], ['PFL', 'Purfleet'], ['SWE', 'Swineshead'], ['SHB', 'Shirebrook'], ['DFD', 'Dartford'], ['HAN', 'Hanwell'], ['NUT', 'Nutbourne'], ['MLW', 'Marlow'], ['WBL', 'Warblington'], ['RHI', 'Rhiwbina'], ['DEP', 'Deptford'], ['CUB', 'Cumbernauld'], ['HCN', 'Headcorn'], ['LAW', 'Landywood'], ['THC', 'Thurnscoe'], ['CNO', 'Chetnole'], ['COI', 'Crosshill'], ['SHW', 'Shawford'], ['BAJ', 'Baglan'], ['SUR', 'Surbiton'], ['AUK', 'Auchinleck'], ['KTL', 'Kirton Lindsey'], ['LID', 'Lidlington'], ['CDR', 'Cardross'], ['SYL', 'Syon Lane'], ['HYT', 'Hyde North'], ['LAI', 'Laindon'], ['HOX', 'Hoxton'], ['LEW', 'Lewisham'], ['BSK', 'Basingstoke'], ['CRW', 'Crawley'], ['GBS', 'Goring-by-Sea'], ['WHS', 'Whyteleafe South'], ['MHR', 'Market Harborough'], ['ERD', 'Erdington'], ['GST', 'Gathurst'], ['LGG', 'Langley Green'], ['OVR', 'Overton'], ['NEH', 'New Eltham'], ['SDN', 'St Denys'], ['MTG', 'Mottingham'], ['WTR', 'Wateringbury'], ['CDB', 'Cardiff Bay'], ['FNT', 'Feniton'], ['BLP', 'Belper'], ['HSG', 'Hathersage'], ['HVH', 'Hoek Van Holland'], ['DVN', 'Davenport'], ['LWH', 'Lawrence Hill'], ['WCK', 'Wick'], ['BMB', 'Bamber Bridge'], ['DRI', 'Drigg'], ['TWN', 'Town Green'], ['CHE', 'Cheam'], ['SAX', 'Saxmundham'], ['MAG', 'Maghull'], ['SBE', 'Starbeck'], ['MCN', 'Machynlleth'], ['CBC', 'Coatbridge Central'], ['BYL', 'Barry Links'], ['BEM', 'Bempton'], ['SFR', 'Shalford'], ['BIC', 'Billericay'], ['BTR', 'Braintree'], ['ISL', 'Isleworth'], ['HLN', 'Harlington'], ['SSM', 'Stocksmoor'], ['GMN', 'Great Missenden'], ['KNE', 'Kennett'], ['POO', 'Poole'], ['RNR', 'Roughton Road'], ['ILK', 'Ilkley'], ['PMH', 'Portsmouth Harbour'], ['RDA', 'Redland'], ['FRS', 'Forsinard'], ['HRN', 'Hornsey'], ['SLY', 'Selly Oak'], ['OXT', 'Oxted'], ['CBS', 'Coatbridge Sunnyside'], ['WMD', 'Wymondham'], ['TEY', 'Teynham'], ['BAV', 'Barrow Haven'], ['BYE', 'Bynea'], ['WKB', 'West Kilbride'], ['BCU', 'Brockenhurst'], ['AMT', 'Aldermaston'], ['LGB', 'Langbank'], ['MRF', 'Moorfields'], ['PMH', 'Portsmouth Harbour'], ['ROO', 'Roose'], ['KIL', 'Kildonan'], ['BHC', 'Balloch'], ['WIV', 'Wivenhoe'], ['BTT', 'Battersby'], ['CCT', 'Cathcart'], ['HRL', 'Harlech'], ['RGW', 'Ramsgreave & Wilpshire'], ['WVF', 'Wivelsfield'], ['SAJ', 'St Johns'], ['WDH', 'Woodhouse'], ['FOG', 'Forest Gate'], ['HTF', 'Hartford'], ['WNW', 'West Norwood'], ['CSG', 'Cressington'], ['SHU', 'Stonehouse'], ['WDN', 'Walsden'], ['SAC', 'St Albans'], ['WFF', 'Whifflet'], ['HOW', 'Howden'], ['MLY', 'Morley'], ['ASG', 'Alsager'], ['LOB', 'Longbridge'], ['WOM', 'Wombwell'], ['MSH', 'Mossley Hill'], ['ECP', 'Energlyn & Churchill Park'], ['EPH', 'Elephant & Castle'], ['RDW', 'Reading West'], ['EKB', 'Eskbank'], ['BRU', 'Bruton'], ['CME', 'Combe'], ['MIH', 'Mills Hill'], ['PPD', 'Pontypridd'], ['SAD', 'Sandwell & Dudley'], ['KGT', 'Kilgetty'], ['BRI', 'Bristol Temple Meads'], ['HOC', 'Hockley'], ['LBR', 'Llanbedr'], ['NSG', 'New Southgate'], ['DGC', 'Denham Golf Club'], ['PNM', 'Penmere'], ['MHS', 'Meadowhall'], ['PSL', 'Port Sunlight'], ['DWW', 'Dawlish Warren'], ['RTN', 'Renton'], ['BUJ', 'Burton Joyce'], ['HUR', 'Hurst Green'], ['BDK', 'Baldock'], ['LNY', 'Langley'], ['BSH', 'Bushey'], ['DOW', 'Downham Market'], ['KIN', 'Kingussie'], ['BLO', 'Blaydon'], ['DVY', 'Dovey Junction'], ['BWS', 'Barrow Upon Soar'], ['SGL', 'South Gyle'], ['WHT', 'Whitchurch (Glamorgan)'], ['ACB', 'Acton Bridge'], ['ZHA', 'Hammersmith Underground'], ['WRB', 'Wrabness'], ['NQU', 'North Queensferry'], ['TYC', 'Ty Croes'], ['ANC', 'Ancaster'], ['NBN', 'New Brighton'], ['HEC', 'Heckington'], ['QUI', 'Quintrell Downs'], ['WCX', 'Wembley Stadium'], ['LWT', 'Lowestoft'], ['RAN', 'Rannoch'], ['THU', 'Thurgarton'], ['CSK', 'Calstock'], ['MER', 'Merthyr Tydfil'], ['NEI', 'Neilston'], ['CBD', 'Conon Bridge'], ['DNO', 'Dunrobin Castle'], ['HUD', 'Huddersfield'], ['SKW', 'Stoke Newington'], ['ARG', 'Arisaig'], ['CNW', 'Conwy'], ['MNN', 'Menston'], ['PLE', 'Pollokshields East'], ['LLO', 'Llandrindod'], ['LAU', 'Laurencekirk'], ['MSL', 'Mossley'], ['SIE', 'Sherburn-in-Elmet'], ['CBH', 'Cambridge Heath'], ['KBN', 'Kilburn High Road'], ['SID', 'Sidcup'], ['FEL', 'Feltham'], ['CCC', 'Criccieth'], ['STO', 'South Tottenham'], ['WOO', 'Wool'], ['GRK', 'Gourock'], ['LLI', 'Llandybie'], ['AXM', 'Axminster'], ['WGV', 'Wargrave'], ['HSD', 'Hamstead'], ['PLW', 'Pollokshields West'], ['BRK', 'Berwick (Sussex)'], ['CTW', 'Church & Oswaldtwistle'], ['XIB', 'Bourg St Maurice'], ['SKI', 'Skipton'], ['BDM', 'Bedford'], ['PLM', 'Plumley'], ['YVJ', 'Yeovil Junction'], ['DEN', 'Dean'], ['DAM', 'Dalmeny'], ['WGN', 'Wigan North Western'], ['WRE', 'Wrenbury'], ['RYN', 'Roydon'], ['YVJ', 'Yeovil Junction'], ['ABH', 'Abererch'], ['UNI', 'University'], ['AMY', 'Amberley'], ['CSB', 'Carshalton Beeches'], ['EFF', 'Effingham Junction'], ['SVK', 'Seven Kings'], ['DEA', 'Deal'], ['WNP', 'Wanstead Park'], ['ALK', 'Aslockton'], ['ULV', 'Ulverston'], ['LIV', 'Liverpool Lime Street'], ['ABC', 'Altnabreac'], ['LAP', 'Lapford'], ['NIT', 'Nitshill'], ['RAM', 'Ramsgate'], ['KNO', 'Knottingley'], ['LIV', 'Liverpool Lime Street'], ['CSH', 'Carshalton'], ['BFE', 'Bere Ferrers'], ['AVY', 'Aberdovey'], ['CBK', 'Cranbrook (Devon)'], ['WLN', 'Wellington (Shropshire)'], ['CGN', 'Cogan'], ['ASC', 'Ashchurch for Tewkesbury'], ['AVF', 'Avoncliff'], ['CBP', 'Castle Bar Park'], ['GSL', 'Gunnislake'], ['HMC', 'Hampton Court'], ['PLY', 'Plymouth'], ['CLA', 'Clandon'], ['CNE', 'Colne'], ['NXG', 'New Cross Gate'], ['CIL', 'Chilham'], ['FLI', 'Flixton'], ['NWX', 'New Cross'], ['BMY', 'Bramley (Hampshire)'], ['CWS', 'Caersws'], ['BHO', 'Blackhorse Road'], ['CFT', 'Crofton Park'], ['GLS', 'Glaisdale'], ['WMI', 'Wildmill'], ['AST', 'Aston'], ['CDT', 'Caldicot'], ['ESD', 'Elmstead Woods'], ['KLN', 'Kings Lynn'], ['SLQ', 'St Leonards Warrior Square'], ['PNC', 'Penychain'], ['BUB', 'Burnley Barracks'], ['BNC', 'Burnley Central'], ['AXM', 'Axminster'], ['AXM', 'Axminster'], ['BGS', 'Bogston'], ['BAC', 'Bache'], ['HWW', 'How Wood'], ['BNG', 'Bangor (Gwynedd)'], ['BRM', 'Barmouth'], ['DNL', 'Dunlop'], ['EML', 'East Malling'], ['CMO', 'Camelon'], ['EDY', 'East Didsbury'], ['SPR', 'Springburn'], ['ELE', 'Elmers End'], ['WKI', 'West Kirby'], ['LBZ', 'Leighton Buzzard'], ['WES', 'Westerton'], ['LYD', 'Lydney'], ['PYT', 'Poynton'], ['RCC', 'Redcar Central'], ['CWE', 'Crowle'], ['KNA', 'Knaresborough'], ['RCE', 'Redcar East'], ['BUH', 'Brough'], ['DAN', 'Darnall'], ['WNF', 'Winchfield'], ['WKF', 'Wakefield Westgate'], ['PWY', 'Patchway'], ['DZY', 'Danzey'], ['FLD', 'Fauldhouse'], ['WPL', 'Worplesdon'], ['BSL', 'Beasdale'], ['KKD', 'Kirkdale'], ['EAG', 'Eaglescliffe'], ['CRM', 'Cramlington'], ['SIH', 'St Helier'], ['HBY', 'Hartlebury'], ['COA', 'Coatdyke'], ['CHW', 'Chalkwell'], ['RYS', 'Royston'], ['DVH', 'Dove Holes'], ['HEV', 'Hever'], ['SPA', 'Spalding'], ['BOG', 'Bognor Regis'], ['EUS', 'London Euston'], ['FRL', 'Fairlie'], ['EDB', 'Edinburgh'], ['MRR', 'Morar'], ['WSH', 'Wishaw'], ['CPW', 'Chepstow'], ['SUU', 'Sunbury'], ['HAP', 'Hatfield Peverel'], ['OUN', 'Oulton Broad North'], ['MIC', 'Micheldever'], ['WOF', 'Worcester Foregate Street'], ['WRX', 'Wrexham General'], ['OUS', 'Oulton Broad South'], ['CAK', 'Cark'], ['FRY', 'Ferriby'], ['FOH', 'Forest Hill'], ['STY', 'Stratford Parkway'], ['OLF', 'Oldfield Park'], ['WAL', 'Walton-on-Thames'], ['PTT', 'Patterton'], ['GLQ', 'Glasgow Queen Street'], ['EBA', 'Euxton Balshaw Lane'], ['HLM', 'Holmwood'], ['FAV', 'Faversham'], ['GOL', 'Golspie'], ['KKH', 'Kirkhill'], ['WSR', 'Woodsmoor'], ['CNL', 'Canley'], ['SPT', 'Stockport'], ['WBD', 'Whitley Bridge'], ['HIA', 'Hampton-in-Arden'], ['BLV', 'Belle Vue'], ['DMK', 'Denmark Hill'], ['DWL', 'Dawlish'], ['FLF', 'Flowery Field'], ['DGY', 'Deganwy'], ['SYS', 'Syston'], ['KKN', 'Kirknewton'], ['WBO', 'Wimbledon Chase'], ['ALB', 'Albrighton'], ['BEP', 'Bermuda Park (Nuneaton)'], ['BFN', 'Byfleet & New Haw'], ['SKM', 'Stoke Mandeville'], ['NEM', 'New Malden'], ['SER', 'St Erth'], ['GNL', 'Green Lane'], ['HEI', 'Heighington'], ['OMS', 'Ormskirk'], ['HBN', 'Hollingbourne'], ['COL', 'Colchester'], ['MES', 'Melton'], ['AHV', 'Ash Vale'], ['KRK', 'Kirkconnel'], ['BYN', 'Bryn'], ['CWC', 'Chappel & Wakes Colne'], ['BIK', 'Birkbeck'], ['SWM', 'Swanscombe'], ['AUD', 'Audley End'], ['BRE', 'Brentwood'], ['YOK', 'Yoker'], ['AHS', 'Ashurst'], ['GSW', 'Garswood'], ['SHU', 'Stonehouse'], ['SNR', 'Sanderstead'], ['BRC', 'Breich'], ['HDM', 'Haddenham & Thame Parkway'], ['BAH', 'Bank Hall'], ['PRR', 'Princes Risborough'], ['SYA', 'Styal'], ['GPO', 'Gospel Oak'], ['SLV', 'Silver Street'], ['FZP', 'Furze Platt'], ['MFA', 'Morfa Mawddach'], ['DLG', 'Dolgarrog'], ['CWB', 'Colwyn Bay'], ['HVN', 'Havenhouse'], ['LUT', 'Luton'], ['GIG', 'Giggleswick'], ['KGP', 'Kings Park'], ['RYH', 'Rye House'], ['GOR', 'Goring & Streatley'], ['HFD', 'Hereford'], ['BIG', 'Billingshurst'], ['STJ', 'Severn Tunnel Junction'], ['SAU', 'St Austell'], ['WHS', 'Whyteleafe South'], ['WST', 'Wood Street'], ['LED', 'Ledbury'], ['MRF', 'Moorfields'], ['OLF', 'Oldfield Park'], ['ATN', 'Atherton'], ['BRS', 'Berrylands'], ['WSB', 'Westbury'], ['CYS', 'Cathays'], ['CWD', 'Creswell'], ['LOS', 'Lostwithiel'], ['BHS', 'Brockholes'], ['THT', 'Thorntonhall'], ['DRG', 'Drayton Green'], ['ANS', 'Ainsdale'], ['DYP', 'Drayton Park'], ['KLY', 'Kenley'], ['LEH', 'Lea Hall'], ['LPR', 'Long Preston'], ['SVS', 'Seven Sisters'], ['WWW', 'Wootton Wawen'], ['SHI', 'Shiplake'], ['WML', 'Wilmslow'], ['EDL', 'Edale'], ['FLX', 'Felixstowe'], ['NBR', 'Narborough'], ['PFY', 'Poulton-le-Fylde'], ['PRP', 'Preston Park'], ['COE', 'Coombe Junction Halt'], ['SST', 'Stansted Mountfitchet'], ['WLD', 'West St Leonards'], ['PMW', 'Penmaenmawr'], ['YEO', 'Yeoford'], ['YVP', 'Yeovil Pen Mill'], ['GRF', 'Garforth'], ['MON', 'Monifieth'], ['NOR', 'Normanton'], ['COM', 'Commondale'], ['ZFD', 'Farringdon Underground'], ['ORR', 'Orrell'], ['LOW', 'Lowdham'], ['YVP', 'Yeovil Pen Mill'], ['HWF', 'Heathrow Airport T4 (Bus)'], ['LPG', 'Llanfairpwll'], ['LWR', 'Llanrwst'], ['CRN', 'Crowthorne'], ['JCH', 'James Cook'], ['LLS', 'Llanishen'], ['NCE', 'New Clee'], ['RAY', 'Raynes Park'], ['SAW', 'Sawbridgeworth'], ['WLO', 'Waterloo (Merseyside)'], ['ROE', 'Rotherhithe'], ['HNB', 'Herne Bay'], ['SHY', 'Shipley'], ['MTA', 'Mountain Ash'], ['SJP', 'St James\' Park'], ['LYC', 'Lympstone Commando'], ['NWM', 'New Milton'], ['WIJ', 'Willesden Junction'], ['FLT', 'Flitwick'], ['BRA', 'Brora'], ['HYN', 'Hyndland'], ['RUF', 'Rufford'], ['PTA', 'Port Talbot Parkway'], ['SMH', 'Stamford Hill'], ['GVE', 'Garve'], ['HTE', 'Hatch End'], ['WSE', 'Winchelsea'], ['DLT', 'Dalton'], ['SPY', 'Shepley'], ['CFL', 'Crossflatts'], ['LIH', 'Leigh (Kent)'], ['LYM', 'Lympstone Village'], ['SOL', 'Solihull'], ['CTH', 'Chadwell Heath'], ['FOK', 'Four Oaks'], ['TRI', 'Tring'], ['BLB', 'Battlesbridge'], ['FAL', 'Falmouth Docks'], ['HPL', 'Hartlepool'], ['OXN', 'Oxenholme Lake District'], ['OTF', 'Otford'], ['OUT', 'Outwood'], ['WLE', 'Whittlesea'], ['SBV', 'St Budeaux Victoria Road'], ['HHY', 'Highbury & Islington'], ['CKS', 'Clarkston'], ['EDN', 'Eden Park'], ['SDP', 'Sandplace'], ['AFK', 'Ashford International'], ['DLM', 'Delamere'], ['HHY', 'Highbury & Islington'], ['INK', 'Inverkeithing'], ['SAA', 'St Albans Abbey'], ['HLB', 'Hildenborough'], ['KTH', 'Kent House'], ['BUL', 'Butlers Lane'], ['AML', 'Acton Main Line'], ['FMT', 'Falmouth Town'], ['BAM', 'Bamford'], ['FFD', 'Freshford'], ['WAT', 'London Waterloo'], ['SHN', 'Shanklin'], ['CKT', 'Crookston'], ['BKL', 'Bickley'], ['DND', 'Dinsdale'], ['NCL', 'Newcastle'], ['WLV', 'Wallasey Village'], ['THS', 'Thurso'], ['ZBS', 'Baker Street Underground'], ['WAE', 'London Waterloo East'], ['TIS', 'Tisbury'], ['BXS', 'Brussels Midi'], ['LEA', 'Leagrave'], ['BAB', 'Balcombe'], ['NCZ', 'Newcastle Central Metro'], ['ASH', 'Ash'], ['RDB', 'Redbridge'], ['BBK', 'Bilbrook'], ['BUW', 'Burley-in-Wharfedale'], ['GBD', 'Gilberdyke'], ['NSB', 'Normans Bay'], ['RGT', 'Rugeley Town'], ['SEH', 'Shoreham (Kent)'], ['BSH', 'Bushey'], ['ELG', 'Elgin'], ['FTN', 'Fratton'], ['EBN', 'Eastbourne'], ['FTM', 'Fort Matilda'], ['MBK', 'Millbrook (Hampshire)'], ['POT', 'Pontefract Tanshelf'], ['WGW', 'Wigan Wallgate'], ['SUO', 'Sutton (Surrey)'], ['AYS', 'Aylesbury'], ['LVM', 'Levenshulme'], ['WAD', 'Wadhurst'], ['PGN', 'Paignton'], ['BOC', 'Bootle'], ['BUG', 'Burgess Hill'], ['AHD', 'Ashtead'], ['OKL', 'Oakleigh Park'], ['LTT', 'Little Sutton'], ['BAU', 'Barton-on-Humber'], ['GWE', 'Gwersyllt'], ['PMH', 'Portsmouth Harbour'], ['SBU', 'Southbury'], ['CDF', 'Cardiff Central'], ['DTW', 'Droitwich Spa'], ['FST', 'London Fenchurch Street'], ['CEY', 'Cononley'], ['HML', 'Hemel Hempstead'], ['OKN', 'Oakengates'], ['CGD', 'Craigendoran'], ['PEM', 'Pemberton'], ['NHL', 'New Holland'], ['SNP', 'Stanhope'], ['EST', 'Easterhouse'], ['GRA', 'Grantham'], ['TAP', 'Taplow'], ['SUC', 'Sutton Common'], ['GNH', 'Greenhithe for Bluewater'], ['NCT', 'Newark Castle'], ['BTD', 'Bolton-on-Dearne'], ['HNC', 'Hamilton Central'], ['ECL', 'Eccleston Park'], ['OLY', 'Ockley'], ['PLD', 'Portslade'], ['BBG', 'Bishopbriggs'], ['COP', 'Copplestone'], ['SDB', 'Sandbach'], ['COV', 'Coventry'], ['EXD', 'Exeter St Davids'], ['LTH', 'Llanhilleth'], ['SQH', 'Sanquhar'], ['ERA', 'Eastham Rake'], ['BSK', 'Basingstoke'], ['MIR', 'Mirfield'], ['PFM', 'Pontefract Monkhill'], ['GUN', 'Gunnersbury'], ['WLG', 'Wallasey Grove Road'], ['PBO', 'Peterborough'], ['PLU', 'Plumstead'], ['CDQ', 'Cardiff Queen Street'], ['BXB', 'Broxbourne'], ['HNW', 'Hamilton West'], ['EXT', 'Exeter St Thomas'], ['WLT', 'Wallington'], ['HNX', 'Hunts Cross'], ['HMP', 'Hampton'], ['ALF', 'Alfreton'], ['BAA', 'Barnham'], ['SEA', 'Seaham'], ['WBY', 'West Byfleet'], ['BGL', 'Bugle'], ['WRK', 'Worksop'], ['WWI', 'West Wickham'], ['FGT', 'Faygate'], ['STW', 'Strawberry Hill'], ['NFL', 'Northfleet'], ['BUE', 'Bures'], ['NMP', 'Northampton'], ['CBL', 'Cambuslang'], ['GFN', 'Giffnock'], ['INV', 'Inverness'], ['WGR', 'Woodgrange Park'], ['STS', 'Saltash'], ['STP', 'London St Pancras (Intl)'], ['SUN', 'Sunderland'], ['SDF', 'Saundersfoot'], ['FNV', 'Furness Vale'], ['YAE', 'Yate'], ['MCV', 'Manchester Victoria'], ['RED', 'Redruth'], ['SNG', 'Sunningdale'], ['PDG', 'Padgate'], ['HTR', 'Heathrow Central Bus Stn'], ['BHI', 'Birmingham International'], ['CWH', 'Crews Hill'], ['NTA', 'Newton Abbot'], ['SFA', 'Stratford International'], ['WOH', 'Woldingham'], ['SXY', 'Saxilby'], ['GKC', 'Greenock Central'], ['PTC', 'Portchester'], ['GLD', 'Guildford'], ['BNF', 'Briton Ferry'], ['DAG', 'Dalgety Bay'], ['SOO', 'Strood'], ['DLS', 'Dalston'], ['LFD', 'Lingfield'], ['BBN', 'Blackburn'], ['CGM', 'Cottingham'], ['RVB', 'Ravensbourne'], ['AIR', 'Airbles'], ['BRR', 'Barrhead'], ['CLH', 'Clitheroe'], ['MRM', 'Manors (T & W Metro)'], ['GMT', 'Grosmont'], ['DHM', 'Durham'], ['PAR', 'Par'], ['IVY', 'Ivybridge'], ['LVN', 'Littlehaven'], ['GKW', 'Greenock West'], ['HNK', 'Hinckley'], ['KMK', 'Kilmarnock'], ['RMD', 'Richmond'], ['SIC', 'Silecroft'], ['HAD', 'Haddiscoe'], ['DNM', 'Denham'], ['OXS', 'Oxshott'], ['SLB', 'Saltburn'], ['DNT', 'Dent'], ['WHY', 'Whyteleafe'], ['CRG', 'Cross Gates'], ['LCG', 'Lochgelly'], ['BHG', 'Bathgate'], ['TNF', 'Tonfanau'], ['MAL', 'Malden Manor'], ['NUT', 'Nutbourne'], ['NWX', 'New Cross'], ['TON', 'Tonbridge'], ['TRO', 'Trowbridge'], ['WKG', 'Workington'], ['BSI', 'Balmossie'], ['SMK', 'Stowmarket'], ['LGD', 'Lingwood'], ['FBY', 'Formby'], ['NNP', 'Ninian Park'], ['ADM', 'Adisham'], ['GRL', 'Greenfaulds'], ['RLN', 'Rowlands Castle'], ['AMF', 'Ammanford'], ['KMP', 'Kempton Park'], ['SNL', 'Stoneleigh'], ['BWB', 'Bow Brickhill'], ['ABY', 'Ashburys'], ['BRY', 'Barry'], ['MYL', 'Maryland'], ['BBL', 'Bat & Ball'], ['PUT', 'Putney'], ['CAA', 'Coventry Arena'], ['HMD', 'Hampden Park'], ['GYP', 'Gypsy Lane'], ['CMY', 'Crossmyloof'], ['DUL', 'Dullingham'], ['WNM', 'Weston Milton'], ['AFV', 'Ansdell & Fairhaven'], ['SYH', 'Sydenham Hill'], ['GTW', 'Gatwick Airport'], ['HYK', 'Hoylake'], ['MIS', 'Mistley'], ['PPK', 'Possilpark & Parkhouse'], ['WYM', 'Wylam'], ['MLM', 'Millom'], ['WAV', 'Wavertree Tech Park'], ['LAM', 'Lamphey'], ['CCH', 'Chichester'], ['MLT', 'Malton'], ['SGM', 'St Germans'], ['WND', 'Wendover'], ['HAF', 'Heathrow Airport T4'], ['THE', 'Theale'], ['ADL', 'Adlington (Lancashire)'], ['HWV', 'Heathrow Airport T5'], ['PLK', 'Plockton'], ['HWC', 'Harwich Town'], ['CWU', 'Crowhurst'], ['CHK', 'Chiswick'], ['HEN', 'Hendon'], ['DRU', 'Drumgelloch'], ['HAB', 'Habrough'], ['LVT', 'Lisvane & Thornhill'], ['TOK', 'Three Oaks'], ['SVR', 'Silverdale'], ['HEL', 'Hensall'], ['SON', 'Steeton & Silsden'], ['WIC', 'Wickford'], ['NAN', 'Nantwich'], ['LUD', 'Ludlow'], ['AFS', 'Ashford (Surrey)'], ['SGH', 'South Gosforth (T & W Metro)'], ['WYL', 'Wylde Green'], ['RDH', 'Redhill'], ['RNM', 'Rainham (Essex)'], ['MIF', 'Millfield (T & W Metro)'], ['WIN', 'Winchester'], ['LLR', 'Llanharan'], ['NET', 'Netherfield'], ['BSN', 'Boston'], ['GRN', 'Grindleford'], ['APB', 'Appley Bridge'], ['PYN', 'Penryn'], ['SRR', 'Sarn'], ['BND', 'Brandon'], ['DLW', 'Dalwhinnie'], ['BIB', 'Bishops Lydeard'], ['CUX', 'Cuxton'], ['PRS', 'Prees'], ['CLC', 'Castle Cary'], ['SCF', 'Stechford'], ['CLD', 'Chelsfield'], ['RIL', 'Rice Lane'], ['TBY', 'Thornaby'], ['LPY', 'Liverpool South Parkway'], ['CRV', 'Craven Arms'], ['WMA', 'West Malling'], ['DTN', 'Denton'], ['DOC', 'Dockyard'], ['DCH', 'Dorchester South'], ['NXG', 'New Cross Gate'], ['CDS', 'Coulsdon South'], ['LLF', 'Llanfairfechan'], ['SLL', 'Stallingborough'], ['CDO', 'Cardonald'], ['HAT', 'Hatfield'], ['RDN', 'Reddish North'], ['WOS', 'Worcester Shrub Hill'], ['HAV', 'Havant'], ['SNA', 'Sandal & Agbrigg'], ['MIM', 'Moreton-in-Marsh'], ['ART', 'Arrochar & Tarbet'], ['OBN', 'Oban'], ['RDS', 'Reddish South'], ['TOO', 'Tooting'], ['WMC', 'Wilmcote'], ['SIA', 'Southend Airport'], ['EBT', 'Edenbridge Town'], ['PLG', 'Polegate'], ['BSW', 'Birmingham Snow Hill'], ['GRB', 'Great Bentley'], ['HHB', 'Heysham Port'], ['SNK', 'Sankey for Penketh'], ['BXD', 'Buxted'], ['ASK', 'Askam'], ['CFB', 'Catford Bridge'], ['GMG', 'Garth (Mid Glamorgan)'], ['NCM', 'North Camp'], ['APF', 'Appleford'], ['EWR', 'East Worthing'], ['WON', 'Walton-on-the-Naze'], ['ROW', 'Rowley Regis'], ['WSU', 'West Sutton'], ['BGG', 'Brigg'], ['EBD', 'Ebbsfleet International'], ['ZEL', 'Elephant & Castle Underground'], ['PHR', 'Penshurst'], ['MRB', 'Manorbier'], ['SPH', 'Shepherds Well'], ['STD', 'Stroud'], ['TGS', 'Ty Glas'], ['BCF', 'Beaconsfield'], ['HDF', 'Hadfield'], ['CDD', 'Cardenden'], ['LTL', 'Littleborough'], ['CHR', 'Christchurch'], ['MFT', 'Mansfield'], ['PWE', 'Pollokshaws East'], ['LPW', 'Lapworth'], ['BNE', 'Bourne End'], ['CRA', 'Cradley Heath'], ['CHO', 'Cholsey'], ['WRM', 'Wareham'], ['CSR', 'Chassen Road'], ['SEN', 'Shenstone'], ['BOE', 'Botley'], ['ANG', 'Angmering'], ['DVC', 'Dovercourt'], ['PMG', 'Porthmadog Harbour  (Bus)'], ['ORN', 'Old Roan'], ['NGT', 'Newington'], ['KNI', 'Knighton'], ['GVH', 'Gravelly Hill'], ['OXF', 'Oxford'], ['CKY', 'Crosskeys'], ['BLL', 'Bardon Mill'], ['FGH', 'Fishguard Harbour'], ['LYE', 'Lye'], ['CLR', 'Clarbeston Road'], ['HBD', 'Hebden Bridge'], ['IGD', 'Invergordon'], ['YNW', 'Ynyswen'], ['PWW', 'Pollokshaws West'], ['RMB', 'Roman Bridge'], ['GRT', 'Grateley'], ['AGT', 'Aldrington'], ['CED', 'Cheddington'], ['RVN', 'Ravensthorpe'], ['KEN', 'Kendal'], ['MAR', 'Margate'], ['PSE', 'Pitsea'], ['CTK', 'City Thameslink'], ['BAT', 'Battle'], ['HEV', 'Hever'], ['WAS', 'Watton-at-Stone'], ['CLY', 'Chinley'], ['HES', 'Hessle'], ['UPH', 'Upper Halliford'], ['WNS', 'Winnersh'], ['AON', 'Alton'], ['LGK', 'Longbeck'], ['SHC', 'Streethouse'], ['EMS', 'Emsworth'], ['SYH', 'Sydenham Hill'], ['BAK', 'Battersea Park'], ['GLQ', 'Glasgow Queen Street'], ['BKJ', 'Beckenham Junction'], ['UMB', 'Umberleigh'], ['CMN', 'Carmarthen'], ['SHH', 'Shirehampton'], ['MAX', 'Maxwell Park'], ['HGY', 'Harringay'], ['AVF', 'Avoncliff'], ['BYK', 'Bentley (South Yorkshire)'], ['GER', 'Gerrards Cross'], ['HLR', 'Hall Road'], ['HNF', 'Hednesford'], ['FRD', 'Frodsham'], ['KNR', 'Kensal Rise'], ['BCC', 'Beccles'], ['HGN', 'Hough Green'], ['BKW', 'Berkswell'], ['EBR', 'Edenbridge'], ['BKT', 'Blake Street'], ['CEH', 'Coleshill Parkway'], ['LEN', 'Lenham'], ['BEC', 'Beckenham Hill'], ['FNY', 'Finchley Road & Frognal'], ['LTM', 'Lytham'], ['BKJ', 'Beckenham Junction'], ['KDG', 'Kidsgrove'], ['IGD', 'Invergordon'], ['CPH', 'Caerphilly'], ['APS', 'Apsley'], ['HTY', 'Hattersley'], ['SAL', 'Salisbury'], ['BNW', 'Bootle New Strand'], ['SOB', 'Southbourne'], ['BTH', 'Bath Spa'], ['DFE', 'Dunfermline Town'], ['SLS', 'Shettleston'], ['ELY', 'Ely'], ['BMF', 'Broomfleet'], ['NVH', 'Newhaven Harbour'], ['LCL', 'Lochailort'], ['PMD', 'Pembroke Dock'], ['WAR', 'Ware'], ['BFD', 'Brentford'], ['GLZ', 'Glazebrook'], ['HSY', 'Horsley'], ['SPI', 'Spital'], ['SHZ', 'South Hylton (T & W Metro)'], ['MOO', 'Muir of Ord'], ['NHD', 'Nunhead'], ['BKR', 'Blackridge'], ['IRL', 'Irlam'], ['NVN', 'Newhaven Town'], ['WRN', 'West Runton'], ['HDB', 'Haydon Bridge'], ['EAD', 'Earlsfield'], ['RDM', 'Riding Mill'], ['WMR', 'Widney Manor'], ['BPK', 'Brookmans Park'], ['WLF', 'Whittlesford Parkway'], ['GDN', 'Godstone'], ['TFC', 'Telford Central'], ['SHE', 'Sherborne'], ['GNB', 'Gainsborough Central'], ['BOT', 'Bootle Oriel Road'], ['EGR', 'East Grinstead'], ['LNK', 'Lanark'], ['NEG', 'Newtongrange'], ['SAL', 'Salisbury'], ['CFR', 'Chandlers Ford'], ['LGM', 'Langley Mill'], ['GSD', 'Garsdale'], ['LAG', 'Langwith-Whaley Thorns'], ['BNL', 'Barnhill'], ['IVR', 'Iver'], ['CNY', 'Cantley'], ['HGS', 'Hastings'], ['BEY', 'Ben Rhydding'], ['BMD', 'Brimsdown'], ['ARB', 'Arbroath'], ['BLN', 'Blundellsands & Crosby'], ['MSS', 'Moses Gate'], ['DST', 'Duke Street'], ['HYW', 'Hinchley Wood'], ['AYR', 'Ayr'], ['SRO', 'Shireoaks'], ['CAR', 'Carlisle'], ['DSY', 'Daisy Hill'], ['RGL', 'Rugeley Trent Valley'], ['GFF', 'Gilfach Fargoed'], ['WAF', 'Wallyford'], ['INR', 'Inverurie'], ['SBK', 'South Bank'], ['ELO', 'Elton & Orston'], ['SPB', 'Shepherds Bush'], ['STE', 'Streatham'], ['CYB', 'Cefn-y-Bedd'], ['HDY', 'Headingley'], ['HCT', 'Huncoat'], ['DYC', 'Dyce'], ['HYD', 'Heyford'], ['PRH', 'Penrhyndeudraeth'], ['SET', 'Settle'], ['WFH', 'Watford High Street'], ['DLR', 'Dalreoch'], ['BKD', 'Blakedown'], ['PTM', 'Porthmadog'], ['ORP', 'Orpington'], ['GBL', 'Gainsborough Lea Road'], ['SCU', 'Scunthorpe'], ['PTH', 'Perth'], ['TAM', 'Tamworth'], ['TRB', 'Treherbert'], ['BXY', 'Bexley'], ['TRY', 'Treorchy'], ['HRS', 'Horsforth'], ['SHV', 'Southsea Hoverport (Bus)'], ['SUM', 'Summerston'], ['WFJ', 'Watford Junction'], ['FYS', 'Ferryside'], ['NUM', 'Northumberland Park'], ['SVL', 'Staveley'], ['CYK', 'Clydebank'], ['HDN', 'Harlesden'], ['PLS', 'Pleasington'], ['TLC', 'Tal-y-Cafn'], ['WAM', 'Walmer'], ['BMG', 'Barming'], ['IFD', 'Ilford'], ['GTA', 'Great Ayton'], ['NBC', 'New Beckenham'], ['LUD', 'Ludlow'], ['FNR', 'Farningham Road'], ['CFN', 'Clifton Down'], ['HAC', 'Hackney Downs'], ['PGM', 'Pengam'], ['RLG', 'Rayleigh'], ['BKG', 'Barking'], ['BLM', 'Belmont'], ['NTC', 'Newton St Cyres'], ['RYE', 'Rye'], ['DBG', 'Mottisfont & Dunbridge'], ['NWI', 'Northwich'], ['PSC', 'Prescot'], ['DKD', 'Dunkeld & Birnam'], ['AGL', 'Abergele & Pensarn'], ['CRF', 'Carfin'], ['SOM', 'South Milford'], ['CRY', 'Crayford'], ['LIU', 'Lille Europe'], ['GLF', 'Glenfinnan'], ['SWI', 'Swindon'], ['SCR', 'St Columb Road'], ['TEO', 'Theobalds Grove'], ['BHM', 'Birmingham New Street'], ['BML', 'Bramhall'], ['WIJ', 'Willesden Junction'], ['COS', 'Cosford'], ['ACG', 'Acocks Green'], ['DVP', 'Dover Priory'], ['MOG', 'Moorgate'], ['ROS', 'Rosyth'], ['WAO', 'Walton (Merseyside)'], ['GNH', 'Greenhithe for Bluewater'], ['RWC', 'Rawcliffe'], ['LES', 'Leigh-on-Sea'], ['HLI', 'Healing'], ['WEY', 'Weymouth'], ['AFK', 'Ashford International'], ['HON', 'Honiton'], ['RCA', 'Risca & Pontymister'], ['BIY', 'Bingley'], ['FOR', 'Forres'], ['KLM', 'Kilmaurs'], ['BOR', 'Bodorgan'], ['BSS', 'Barassie'], ['PUR', 'Purley'], ['MAC', 'Macclesfield'], ['RBR', 'Robertsbridge'], ['HHE', 'Haywards Heath'], ['ALN', 'Althorne'], ['GBK', 'Greenbank'], ['BMV', 'Bromsgrove'], ['GTO', 'Gorton'], ['PMB', 'Pembroke'], ['SKE', 'Skewen'], ['CAU', 'Causeland'], ['PEN', 'Penarth'], ['UPT', 'Upton'], ['BMN', 'Bromley North'], ['ZTH', 'Tower Hill Underground'], ['KYL', 'Kyle of Lochalsh'], ['TTN', 'Totton'], ['HWF', 'Heathrow Airport T4 (Bus)'], ['BMS', 'Bromley South'], ['ASS', 'Alness'], ['SSS', 'Sheerness-on-Sea'], ['CAG', 'Carrbridge'], ['GTH', 'Garth (Powys)'], ['LOF', 'London Fields'], ['BIS', 'Bishops Stortford'], ['BRW', 'Brunswick'], ['CHH', 'Christs Hospital'], ['HHD', 'Holyhead'], ['MFL', 'Mount Florida'], ['DAK', 'Dalmarnock'], ['WSW', 'Wandsworth Common'], ['MDN', 'Maiden Newton'], ['DFL', 'Dunfermline Queen Margaret'], ['IRV', 'Irvine'], ['WHN', 'Whiston'], ['SBS', 'St Bees'], ['PKG', 'Penkridge'], ['SOU', 'Southampton Central'], ['COY', 'Coryton'], ['GGJ', 'Georgemas Junction'], ['SLR', 'Sleaford'], ['DKT', 'Dorking West'], ['SQU', 'Squires Gate'], ['CMD', 'Camden Road'], ['BSO', 'Basildon'], ['CBR', 'Cooksbridge'], ['BYM', 'Burnley Manchester Road'], ['MLF', 'Milford (Surrey)'], ['RYR', 'Ryde St Johns Road'], ['TEY', 'Teynham'], ['TOT', 'Totnes'], ['FRF', 'Fairfield'], ['PUO', 'Purley Oaks'], ['GNF', 'Greenfield'], ['GRY', 'Grays'], ['BGH', 'Brighouse'], ['FKG', 'Falkirk Grahamston'], ['HKH', 'Hawkhead'], ['PYP', 'Pont-y-Pant'], ['FKK', 'Falkirk High'], ['SOV', 'Southend Victoria'], ['MEY', 'Merryton']]
);

function findStation(id) {
  const wanted = id.toUpperCase();
  const station = sMap.get(wanted);
  console.log(station);

  return station;
}

module.exports = { findStation };
